// This file is automatically generated from /builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql.pac.

#ifndef _builddir_build_BUILD_bro_2_4_1_src_analyzer_protocol_mysql_mysql_pac_h
#define _builddir_build_BUILD_bro_2_4_1_src_analyzer_protocol_mysql_mysql_pac_h

#include <vector>

#include "binpac.h"


#include "binpac_bro.h"


	#include "events.bif.h"

namespace binpac {

namespace MySQL {
class ContextMySQL;
class MySQL_Conn;
class uint24le;
class LengthEncodedInteger;
class LengthEncodedIntegerLookahead;
class LengthEncodedString;
enum command_consts {
	COM_SLEEP = 0,
	COM_QUIT = 1,
	COM_INIT_DB = 2,
	COM_QUERY = 3,
	COM_FIELD_LIST = 4,
	COM_CREATE_DB = 5,
	COM_DROP_DB = 6,
	COM_REFRESH = 7,
	COM_SHUTDOWN = 8,
	COM_STATISTICS = 9,
	COM_PROCESS_INFO = 10,
	COM_CONNECT = 11,
	COM_PROCESS_KILL = 12,
	COM_DEBUG = 13,
	COM_PING = 14,
	COM_TIME = 15,
	COM_DELAYED_INSERT = 16,
	COM_CHANGE_USER = 17,
	COM_BINLOG_DUMP = 18,
	COM_TABLE_DUMP = 19,
	COM_CONNECT_OUT = 20,
	COM_REGISTER_SLAVE = 21,
	COM_STMT_PREPARE = 22,
	COM_STMT_EXECUTE = 23,
	COM_STMT_SEND_LONG_DATA = 24,
	COM_STMT_CLOSE = 25,
	COM_STMT_RESET = 26,
	COM_SET_OPTION = 27,
	COM_STMT_FETCH = 28,
	COM_DAEMON = 29,
	COM_BINLOG_DUMP_GTID = 30,
};
enum state {
	CONNECTION_PHASE = 0,
	COMMAND_PHASE = 1,
};
enum Expected {
	NO_EXPECTATION,
	EXPECT_STATUS,
	EXPECT_COLUMN_DEFINITION,
	EXPECT_COLUMN_COUNT,
	EXPECT_EOF1,
	EXPECT_EOF2,
	EXPECT_RESULTSET,
	EXPECT_QUERY_RESPONSE,
};
extern RegExMatcher NUL_String_re_001;

class NUL_String;
class MySQL_PDU;
class Header;
class Server_Message;
class Client_Message;
class Initial_Handshake_Packet;
class Handshake_v10;
class Handshake_v9;
class Handshake_Response_Packet;
class Handshake_Response_Packet_v10;
class Handshake_Response_Packet_v9;
class Command_Request_Packet;
class Command_Response;
class Command_Response_Status;
class ColumnCountMeta;
class ColumnCount;
class ColumnDefinitions;
class EOF1;
class EOF2;
class Resultset;
class ResultsetRow;
class ColumnDefinition41;
class ColumnDefinition320;
class OK_Packet;
class ERR_Packet;
class EOF_Packet;
class MySQL_Flow;
} // namespace MySQL

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
namespace MySQL {

class ContextMySQL
{
public:
	ContextMySQL(MySQL_Conn * connection, MySQL_Flow * flow, FlowBuffer * flow_buffer);
	~ContextMySQL();
	
	// Member access functions
	MySQL_Conn * connection() const { return connection_; }
	MySQL_Flow * flow() const { return flow_; }
	FlowBuffer * flow_buffer() const { return flow_buffer_; }
	
protected:
	MySQL_Conn * connection_;
	MySQL_Flow * flow_;
	FlowBuffer * flow_buffer_;
};


class MySQL_Conn : public binpac::ConnectionAnalyzer
{
public:
	MySQL_Conn(BroAnalyzer const & bro_analyzer);
	~MySQL_Conn();
	
	// Member access functions
	MySQL_Flow * upflow() const { return upflow_; }
	MySQL_Flow * downflow() const { return downflow_; }
	BroAnalyzer const & bro_analyzer() const { return bro_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	uint8 get_version();
	bool set_version(uint8 v);
	int get_state();
	bool update_state(state s);
	Expected get_expectation();
	bool set_next_expected(Expected e);
	uint32 get_col_count();
	bool set_col_count(uint32 i);
	
protected:
	
	// Additional members

		uint8 version_;
		int state_;
		Expected expected_;
		uint32 col_count_;
	
	MySQL_Flow * upflow_;
	MySQL_Flow * downflow_;
	BroAnalyzer bro_analyzer_;
};


class uint24le
{
public:
	uint24le();
	~uint24le();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 byte3() const { return byte3_; }
	uint8 byte2() const { return byte2_; }
	uint8 byte1() const { return byte1_; }
	
protected:
	uint8 byte3_;
	uint8 byte2_;
	uint8 byte1_;
};


class LengthEncodedInteger
{
public:
	LengthEncodedInteger();
	~LengthEncodedInteger();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 length() const { return length_; }
	LengthEncodedIntegerLookahead * integer() const { return integer_; }
	
protected:
	uint8 length_;
	LengthEncodedIntegerLookahead * integer_;
};


class LengthEncodedIntegerLookahead
{
public:
	LengthEncodedIntegerLookahead(uint8 length);
	~LengthEncodedIntegerLookahead();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	uint16 i2() const
		{
		switch ( val_case_index() )
			{
			case 252:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:23:i2", val_case_index(), "((int) 0xfc)");
				break;
			}
		return i2_;
		}
	uint24le * i3() const
		{
		switch ( val_case_index() )
			{
			case 253:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:24:i3", val_case_index(), "((int) 0xfd)");
				break;
			}
		return i3_;
		}
	uint64 i4() const
		{
		switch ( val_case_index() )
			{
			case 254:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:25:i4", val_case_index(), "((int) 0xfe)");
				break;
			}
		return i4_;
		}
	uint8 length() const { return length_; }
	
protected:
	int val_case_index_;
	uint16 i2_;
	uint24le * i3_;
	uint64 i4_;
	uint8 length_;
};


class LengthEncodedString
{
public:
	LengthEncodedString();
	~LengthEncodedString();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	LengthEncodedInteger * len() const { return len_; }
	bytestring const & val() const { return val_; }
	
protected:
	LengthEncodedInteger * len_;
	bytestring val_;
};


	class to_int
		{
		public:
		int operator()(uint24le* num) const
			{
			return (num->byte1() << 16) | (num->byte2() << 8) | num->byte3();
			}

		int operator()(LengthEncodedInteger* lei) const
			{
			if ( lei->length() < 0xfb )
				return lei->length();
			else if ( lei->length() == 0xfc )
				return lei->integer()->i2();
			else if ( lei->length() == 0xfd )
				return to_int()(lei->integer()->i3());
			else if ( lei->length() == 0xfe )
				return lei->integer()->i4();
			else
				return 0;
			}

		int operator()(LengthEncodedIntegerLookahead* lei) const
			{
			if ( lei->length() < 0xfb )
				return lei->length();
			else if ( lei->length() == 0xfc )
				return lei->i2();
			else if ( lei->length() == 0xfd )
				return to_int()(lei->i3());
			else if ( lei->length() == 0xfe )
				return lei->i4();
			else
				return 0;
			}
		};


class MySQL_PDU
{
public:
	MySQL_PDU(bool is_orig);
	~MySQL_PDU();
	int initial_buffer_length() const { return 4; }
	bool ParseBuffer(flow_buffer_t t_flow_buffer, ContextMySQL * t_context);
	
	// Member access functions
	Header * hdr() const { return hdr_; }
	int msg_case_index() const	{ return msg_case_index_; }
	Server_Message * server_msg() const
		{
		switch ( msg_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:136:server_msg", msg_case_index(), "false");
				break;
			}
		return server_msg_;
		}
	Client_Message * client_msg() const
		{
		switch ( msg_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:137:client_msg", msg_case_index(), "true");
				break;
			}
		return client_msg_;
		}
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	int state() const { return state_; }
	
protected:
	Header * hdr_;
	int msg_case_index_;
	Server_Message * server_msg_;
	Client_Message * client_msg_;
	bool is_orig_;
	int byteorder_;
	int state_;
	int buffering_state_;
};


class Header
{
public:
	Header();
	~Header();
	int initial_buffer_length() const { return 0; }
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint24le * le_len() const { return le_len_; }
	uint8 seq_id() const { return seq_id_; }
	uint32 len() const { return len_; }
	
protected:
	uint24le * le_len_;
	uint8 seq_id_;
	uint32 len_;
};


class Server_Message
{
public:
	Server_Message(uint8 seq_id);
	~Server_Message();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	Initial_Handshake_Packet * initial_handshake() const
		{
		switch ( val_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:151:initial_handshake", val_case_index(), "((int) 0)");
				break;
			}
		return initial_handshake_;
		}
	Command_Response * command_response() const
		{
		return command_response_;
		}
	uint8 seq_id() const { return seq_id_; }
	
protected:
	int val_case_index_;
	Initial_Handshake_Packet * initial_handshake_;
	Command_Response * command_response_;
	uint8 seq_id_;
};


class Client_Message
{
public:
	Client_Message(int state);
	~Client_Message();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	Handshake_Response_Packet * connection_phase() const
		{
		switch ( val_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:156:connection_phase", val_case_index(), "CONNECTION_PHASE");
				break;
			}
		return connection_phase_;
		}
	Command_Request_Packet * command_phase() const
		{
		switch ( val_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:157:command_phase", val_case_index(), "COMMAND_PHASE");
				break;
			}
		return command_phase_;
		}
	int state() const { return state_; }
	
protected:
	int val_case_index_;
	Handshake_Response_Packet * connection_phase_;
	Command_Request_Packet * command_phase_;
	int state_;
};


class Initial_Handshake_Packet
{
public:
	Initial_Handshake_Packet();
	~Initial_Handshake_Packet();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	uint8 version() const { return version_; }
	int pkt_case_index() const	{ return pkt_case_index_; }
	Handshake_v10 * handshake10() const
		{
		switch ( pkt_case_index() )
			{
			case 10:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:165:handshake10", pkt_case_index(), "((int) 10)");
				break;
			}
		return handshake10_;
		}
	Handshake_v9 * handshake9() const
		{
		switch ( pkt_case_index() )
			{
			case 9:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:166:handshake9", pkt_case_index(), "((int) 9)");
				break;
			}
		return handshake9_;
		}
	ERR_Packet * error() const
		{
		return error_;
		}
	bool set_version() const { return set_version_; }
	int proc() const { return proc_; }
	
protected:
	uint8 version_;
	int pkt_case_index_;
	Handshake_v10 * handshake10_;
	Handshake_v9 * handshake9_;
	ERR_Packet * error_;
	bool set_version_;
	int proc_;
};


class Handshake_v10
{
public:
	Handshake_v10();
	~Handshake_v10();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	bytestring const & server_version() const { return server_version_; }
	uint32 connection_id() const { return connection_id_; }
	bytestring const & auth_plugin_data_part_1() const { return auth_plugin_data_part_1_; }
	uint8 filler_1() const { return filler_1_; }
	uint16 capability_flag_1() const { return capability_flag_1_; }
	uint8 character_set() const { return character_set_; }
	uint16 status_flags() const { return status_flags_; }
	uint16 capability_flags_2() const { return capability_flags_2_; }
	uint8 auth_plugin_data_len() const { return auth_plugin_data_len_; }
	bytestring const & auth_plugin_name() const { return auth_plugin_name_; }
	
protected:
	bytestring server_version_;
	uint32 connection_id_;
	bytestring auth_plugin_data_part_1_;
	uint8 filler_1_;
	uint16 capability_flag_1_;
	uint8 character_set_;
	uint16 status_flags_;
	uint16 capability_flags_2_;
	uint8 auth_plugin_data_len_;
	bytestring auth_plugin_name_;
};


class Handshake_v9
{
public:
	Handshake_v9();
	~Handshake_v9();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	bytestring const & server_version() const { return server_version_; }
	uint32 connection_id() const { return connection_id_; }
	bytestring const & scramble() const { return scramble_; }
	
protected:
	bytestring server_version_;
	uint32 connection_id_;
	bytestring scramble_;
};


class Handshake_Response_Packet
{
public:
	Handshake_Response_Packet();
	~Handshake_Response_Packet();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	Handshake_Response_Packet_v10 * v10_response() const
		{
		switch ( val_case_index() )
			{
			case 10:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:195:v10_response", val_case_index(), "((int) 10)");
				break;
			}
		return v10_response_;
		}
	Handshake_Response_Packet_v9 * v9_response() const
		{
		switch ( val_case_index() )
			{
			case 9:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:196:v9_response", val_case_index(), "((int) 9)");
				break;
			}
		return v9_response_;
		}
	int byteorder() const { return byteorder_; }
	uint8 version() const { return version_; }
	int proc() const { return proc_; }
	
protected:
	int val_case_index_;
	Handshake_Response_Packet_v10 * v10_response_;
	Handshake_Response_Packet_v9 * v9_response_;
	int byteorder_;
	uint8 version_;
	int proc_;
};


class Handshake_Response_Packet_v10
{
public:
	Handshake_Response_Packet_v10();
	~Handshake_Response_Packet_v10();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 cap_flags() const { return cap_flags_; }
	uint32 max_pkt_size() const { return max_pkt_size_; }
	uint8 char_set() const { return char_set_; }
	bytestring const & username() const { return username_; }
	bytestring const & password() const { return password_; }
	
protected:
	uint32 cap_flags_;
	uint32 max_pkt_size_;
	uint8 char_set_;
	bytestring username_;
	bytestring password_;
};


class Handshake_Response_Packet_v9
{
public:
	Handshake_Response_Packet_v9();
	~Handshake_Response_Packet_v9();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint16 cap_flags() const { return cap_flags_; }
	uint24le * max_pkt_size() const { return max_pkt_size_; }
	bytestring const & username() const { return username_; }
	bytestring const & auth_response() const { return auth_response_; }
	int have_db_case_index() const	{ return have_db_case_index_; }
	bytestring const & database() const
		{
		switch ( have_db_case_index() )
			{
			case 8:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:216:database", have_db_case_index(), "((int) 0x8)");
				break;
			}
		return database_;
		}
	bytestring const & password() const { return password_; }
	
protected:
	uint16 cap_flags_;
	uint24le * max_pkt_size_;
	bytestring username_;
	bytestring auth_response_;
	int have_db_case_index_;
	bytestring database_;
	bytestring password_;
};


class Command_Request_Packet
{
public:
	Command_Request_Packet();
	~Command_Request_Packet();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context);
	
	// Member access functions
	uint8 command() const { return command_; }
	bytestring const & arg() const { return arg_; }
	bool update_expectation() const { return update_expectation_; }
	int proc() const { return proc_; }
	
protected:
	uint8 command_;
	bytestring arg_;
	bool update_expectation_;
	int proc_;
};


class Command_Response
{
public:
	Command_Response();
	~Command_Response();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	ColumnCountMeta * col_count_meta() const
		{
		switch ( val_case_index() )
			{
			case 3:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:234:col_count_meta", val_case_index(), "EXPECT_COLUMN_COUNT");
				break;
			}
		return col_count_meta_;
		}
	ColumnDefinitions * col_defs() const
		{
		switch ( val_case_index() )
			{
			case 2:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:235:col_defs", val_case_index(), "EXPECT_COLUMN_DEFINITION");
				break;
			}
		return col_defs_;
		}
	Resultset * resultset() const
		{
		switch ( val_case_index() )
			{
			case 6:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:236:resultset", val_case_index(), "EXPECT_RESULTSET");
				break;
			}
		return resultset_;
		}
	Command_Response_Status * status() const
		{
		switch ( val_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:237:status", val_case_index(), "EXPECT_STATUS");
				break;
			}
		return status_;
		}
	EOF1 * eof1() const
		{
		switch ( val_case_index() )
			{
			case 4:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:238:eof1", val_case_index(), "EXPECT_EOF1");
				break;
			}
		return eof1_;
		}
	EOF2 * eof2() const
		{
		switch ( val_case_index() )
			{
			case 5:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:239:eof2", val_case_index(), "EXPECT_EOF2");
				break;
			}
		return eof2_;
		}
	
protected:
	int val_case_index_;
	ColumnCountMeta * col_count_meta_;
	ColumnDefinitions * col_defs_;
	Resultset * resultset_;
	Command_Response_Status * status_;
	EOF1 * eof1_;
	EOF2 * eof2_;
};


class Command_Response_Status
{
public:
	Command_Response_Status();
	~Command_Response_Status();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	uint8 pkt_type() const { return pkt_type_; }
	int response_case_index() const	{ return response_case_index_; }
	OK_Packet * data_ok() const
		{
		switch ( response_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:246:data_ok", response_case_index(), "((int) 0x00)");
				break;
			}
		return data_ok_;
		}
	EOF_Packet * data_eof() const
		{
		switch ( response_case_index() )
			{
			case 254:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:247:data_eof", response_case_index(), "((int) 0xfe)");
				break;
			}
		return data_eof_;
		}
	ERR_Packet * data_err() const
		{
		switch ( response_case_index() )
			{
			case 255:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:248:data_err", response_case_index(), "((int) 0xff)");
				break;
			}
		return data_err_;
		}
	
protected:
	uint8 pkt_type_;
	int response_case_index_;
	OK_Packet * data_ok_;
	EOF_Packet * data_eof_;
	ERR_Packet * data_err_;
};


class ColumnCountMeta
{
public:
	ColumnCountMeta();
	~ColumnCountMeta();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	uint8 byte() const { return byte_; }
	int pkt_type_case_index() const	{ return pkt_type_case_index_; }
	OK_Packet * ok() const
		{
		switch ( pkt_type_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:256:ok", pkt_type_case_index(), "((int) 0x00)");
				break;
			}
		return ok_;
		}
	ERR_Packet * err() const
		{
		switch ( pkt_type_case_index() )
			{
			case 255:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/mysql/mysql-protocol.pac:257:err", pkt_type_case_index(), "((int) 0xff)");
				break;
			}
		return err_;
		}
	ColumnCount * col_count() const
		{
		return col_count_;
		}
	
protected:
	uint8 byte_;
	int pkt_type_case_index_;
	OK_Packet * ok_;
	ERR_Packet * err_;
	ColumnCount * col_count_;
};


class ColumnCount
{
public:
	ColumnCount(uint8 byte);
	~ColumnCount();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	LengthEncodedIntegerLookahead * le_column_count() const { return le_column_count_; }
	uint8 byte() const { return byte_; }
	uint32 col_num() const { return col_num_; }
	bool update_col_num() const { return update_col_num_; }
	bool update_expectation() const { return update_expectation_; }
	
protected:
	LengthEncodedIntegerLookahead * le_column_count_;
	uint8 byte_;
	uint32 col_num_;
	bool update_col_num_;
	bool update_expectation_;
};


class ColumnDefinitions
{
public:
	ColumnDefinitions();
	~ColumnDefinitions();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	vector<ColumnDefinition41 *> * defs() const { return defs_; }
	bool update_expectation() const { return update_expectation_; }
	
protected:
	vector<ColumnDefinition41 *> * defs_;
	ColumnDefinition41 * defs__elem_;
	bool update_expectation_;
};


class EOF1
{
public:
	EOF1();
	~EOF1();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	EOF_Packet * eof() const { return eof_; }
	bool update_expectation() const { return update_expectation_; }
	
protected:
	EOF_Packet * eof_;
	bool update_expectation_;
};


class EOF2
{
public:
	EOF2();
	~EOF2();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	EOF_Packet * eof() const { return eof_; }
	bool update_expectation() const { return update_expectation_; }
	
protected:
	EOF_Packet * eof_;
	bool update_expectation_;
};


class Resultset
{
public:
	Resultset();
	~Resultset();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	vector<ResultsetRow *> * rows() const { return rows_; }
	bool update_expectation() const { return update_expectation_; }
	int proc() const { return proc_; }
	
protected:
	vector<ResultsetRow *> * rows_;
	ResultsetRow * rows__elem_;
	bool update_expectation_;
	int proc_;
};


class ResultsetRow
{
public:
	ResultsetRow();
	~ResultsetRow();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	vector<LengthEncodedString *> * fields() const { return fields_; }
	
protected:
	vector<LengthEncodedString *> * fields_;
	LengthEncodedString * fields__elem_;
};


class ColumnDefinition41
{
public:
	ColumnDefinition41();
	~ColumnDefinition41();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	LengthEncodedString * catalog() const { return catalog_; }
	LengthEncodedString * schema() const { return schema_; }
	LengthEncodedString * table() const { return table_; }
	LengthEncodedString * org_table() const { return org_table_; }
	LengthEncodedString * name() const { return name_; }
	LengthEncodedString * org_name() const { return org_name_; }
	LengthEncodedInteger * next_len() const { return next_len_; }
	uint16 char_set() const { return char_set_; }
	uint32 col_len() const { return col_len_; }
	uint8 type() const { return type_; }
	uint16 flags() const { return flags_; }
	uint8 decimals() const { return decimals_; }
	
protected:
	LengthEncodedString * catalog_;
	LengthEncodedString * schema_;
	LengthEncodedString * table_;
	LengthEncodedString * org_table_;
	LengthEncodedString * name_;
	LengthEncodedString * org_name_;
	LengthEncodedInteger * next_len_;
	uint16 char_set_;
	uint32 col_len_;
	uint8 type_;
	uint16 flags_;
	uint8 decimals_;
};


class ColumnDefinition320
{
public:
	ColumnDefinition320();
	~ColumnDefinition320();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	LengthEncodedString * table() const { return table_; }
	LengthEncodedString * name() const { return name_; }
	LengthEncodedInteger * length_of_col_len() const { return length_of_col_len_; }
	uint24le * col_len() const { return col_len_; }
	LengthEncodedInteger * type_len() const { return type_len_; }
	uint8 type() const { return type_; }
	
protected:
	LengthEncodedString * table_;
	LengthEncodedString * name_;
	LengthEncodedInteger * length_of_col_len_;
	uint24le * col_len_;
	LengthEncodedInteger * type_len_;
	uint8 type_;
};


class OK_Packet
{
public:
	OK_Packet();
	~OK_Packet();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	LengthEncodedInteger * le_rows() const { return le_rows_; }
	bytestring const & todo() const { return todo_; }
	uint32 rows() const { return rows_; }
	bool update_state() const { return update_state_; }
	int proc() const { return proc_; }
	
protected:
	LengthEncodedInteger * le_rows_;
	bytestring todo_;
	uint32 rows_;
	bool update_state_;
	int proc_;
};


class ERR_Packet
{
public:
	ERR_Packet();
	~ERR_Packet();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	uint16 code() const { return code_; }
	bytestring const & state() const { return state_; }
	bytestring const & msg() const { return msg_; }
	bool update_state() const { return update_state_; }
	int proc() const { return proc_; }
	
protected:
	uint16 code_;
	bytestring state_;
	bytestring msg_;
	bool update_state_;
	int proc_;
};


class EOF_Packet
{
public:
	EOF_Packet();
	~EOF_Packet();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextMySQL * t_context, int t_byteorder);
	
	// Member access functions
	uint16 warnings() const { return warnings_; }
	uint16 status() const { return status_; }
	bool update_state() const { return update_state_; }
	
protected:
	uint16 warnings_;
	uint16 status_;
	bool update_state_;
};


class MySQL_Flow : public binpac::FlowAnalyzer
{
public:
	MySQL_Flow(MySQL_Conn * connection, bool is_orig);
	~MySQL_Flow();
	
	// Member access functions
	FlowBuffer * flow_buffer() const { return flow_buffer_; }
	MySQL_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
	// Functions
	bool proc_mysql_initial_handshake_packet(Initial_Handshake_Packet * msg);
	bool proc_mysql_handshake_response_packet(Handshake_Response_Packet * msg);
	bool proc_mysql_command_request_packet(Command_Request_Packet * msg);
	bool proc_err_packet(ERR_Packet * msg);
	bool proc_ok_packet(OK_Packet * msg);
	bool proc_resultset(Resultset * msg);
	
protected:
	MySQL_PDU * dataunit_;
	ContextMySQL * context_;
	FlowBuffer * flow_buffer_;
	MySQL_Conn * connection_;
	bool is_orig_;
};

} // namespace MySQL
}  // namespace binpac
#endif /* _builddir_build_BUILD_bro_2_4_1_src_analyzer_protocol_mysql_mysql_pac_h */
