// This file is automatically generated from /builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake.pac.

#ifndef _builddir_build_BUILD_bro_2_4_1_src_analyzer_protocol_ssl_tls_handshake_pac_h
#define _builddir_build_BUILD_bro_2_4_1_src_analyzer_protocol_ssl_tls_handshake_pac_h

#include <vector>

#include "binpac.h"


#include "binpac_bro.h"


#include <string>
using std::string;

#include "events.bif.h"


#include <vector>
#include <algorithm>
#include <iostream>
#include <iterator>

#include "util.h"

#include "file_analysis/Manager.h"

namespace binpac {

namespace TLSHandshake {
class ContextTLSHandshake;
class Handshake_Conn;
class uint24;
class uint48;
enum ContentType {
	CHANGE_CIPHER_SPEC = 20,
	ALERT = 21,
	HANDSHAKE = 22,
	APPLICATION_DATA = 23,
	HEARTBEAT = 24,
	V2_ERROR = 300,
	V2_CLIENT_HELLO = 301,
	V2_CLIENT_MASTER_KEY = 302,
	V2_SERVER_HELLO = 304,
	UNKNOWN_OR_V2_ENCRYPTED = 400,
};
enum SSLVersions {
	UNKNOWN_VERSION = 0,
	SSLv20 = 2,
	SSLv30 = 768,
	TLSv10 = 769,
	TLSv11 = 770,
	TLSv12 = 771,
	DTLSv10 = 65279,
	DTLSv12 = 65277,
};
enum SSLExtensions {
	EXT_SERVER_NAME = 0,
	EXT_MAX_FRAGMENT_LENGTH = 1,
	EXT_CLIENT_CERTIFICATE_URL = 2,
	EXT_TRUSTED_CA_KEYS = 3,
	EXT_TRUNCATED_HMAC = 4,
	EXT_STATUS_REQUEST = 5,
	EXT_USER_MAPPING = 6,
	EXT_CLIENT_AUTHZ = 7,
	EXT_SERVER_AUTHZ = 8,
	EXT_CERT_TYPE = 9,
	EXT_ELLIPTIC_CURVES = 10,
	EXT_EC_POINT_FORMATS = 11,
	EXT_SRP = 12,
	EXT_SIGNATURE_ALGORITHMS = 13,
	EXT_USE_SRTP = 14,
	EXT_HEARTBEAT = 15,
	EXT_APPLICATION_LAYER_PROTOCOL_NEGOTIATION = 16,
	EXT_STATUS_REQUEST_V2 = 17,
	EXT_SIGNED_CERTIFICATE_TIMESTAMP = 18,
	EXT_SESSIONTICKET_TLS = 35,
	EXT_EXTENDED_RANDOM = 40,
	EXT_NEXT_PROTOCOL_NEGOTIATION = 13172,
	EXT_ORIGIN_BOUND_CERTIFICATES = 13175,
	EXT_ENCRYPTED_CLIENT_CERTIFICATES = 13180,
	EXT_CHANNEL_ID = 30031,
	EXT_CHANNEL_ID_NEW = 30032,
	EXT_PADDING = 35655,
	EXT_RENEGOTIATION_INFO = 65281,
};
enum ECCurveType {
	EXPLICIT_PRIME = 1,
	EXPLICIT_CHAR = 2,
	NAMED_CURVE = 3,
};
enum TLSCiphers {
	NO_CHOSEN_CIPHER = 16777215,
	TLS_NULL_WITH_NULL_NULL = 0,
	TLS_RSA_WITH_NULL_MD5 = 1,
	TLS_RSA_WITH_NULL_SHA = 2,
	TLS_RSA_EXPORT_WITH_RC4_40_MD5 = 3,
	TLS_RSA_WITH_RC4_128_MD5 = 4,
	TLS_RSA_WITH_RC4_128_SHA = 5,
	TLS_RSA_EXPORT_WITH_RC2_CBC_40_MD5 = 6,
	TLS_RSA_WITH_IDEA_CBC_SHA = 7,
	TLS_RSA_EXPORT_WITH_DES40_CBC_SHA = 8,
	TLS_RSA_WITH_DES_CBC_SHA = 9,
	TLS_RSA_WITH_3DES_EDE_CBC_SHA = 10,
	TLS_DH_DSS_EXPORT_WITH_DES40_CBC_SHA = 11,
	TLS_DH_DSS_WITH_DES_CBC_SHA = 12,
	TLS_DH_DSS_WITH_3DES_EDE_CBC_SHA = 13,
	TLS_DH_RSA_EXPORT_WITH_DES40_CBC_SHA = 14,
	TLS_DH_RSA_WITH_DES_CBC_SHA = 15,
	TLS_DH_RSA_WITH_3DES_EDE_CBC_SHA = 16,
	TLS_DHE_DSS_EXPORT_WITH_DES40_CBC_SHA = 17,
	TLS_DHE_DSS_WITH_DES_CBC_SHA = 18,
	TLS_DHE_DSS_WITH_3DES_EDE_CBC_SHA = 19,
	TLS_DHE_RSA_EXPORT_WITH_DES40_CBC_SHA = 20,
	TLS_DHE_RSA_WITH_DES_CBC_SHA = 21,
	TLS_DHE_RSA_WITH_3DES_EDE_CBC_SHA = 22,
	TLS_DH_ANON_EXPORT_WITH_RC4_40_MD5 = 23,
	TLS_DH_ANON_WITH_RC4_128_MD5 = 24,
	TLS_DH_ANON_EXPORT_WITH_DES40_CBC_SHA = 25,
	TLS_DH_ANON_WITH_DES_CBC_SHA = 26,
	TLS_DH_ANON_WITH_3DES_EDE_CBC_SHA = 27,
	TLS_KRB5_WITH_DES_CBC_SHA = 30,
	TLS_KRB5_WITH_3DES_EDE_CBC_SHA = 31,
	TLS_KRB5_WITH_RC4_128_SHA = 32,
	TLS_KRB5_WITH_IDEA_CBC_SHA = 33,
	TLS_KRB5_WITH_DES_CBC_MD5 = 34,
	TLS_KRB5_WITH_3DES_EDE_CBC_MD5 = 35,
	TLS_KRB5_WITH_RC4_128_MD5 = 36,
	TLS_KRB5_WITH_IDEA_CBC_MD5 = 37,
	TLS_KRB5_EXPORT_WITH_DES_CBC_40_SHA = 38,
	TLS_KRB5_EXPORT_WITH_RC2_CBC_40_SHA = 39,
	TLS_KRB5_EXPORT_WITH_RC4_40_SHA = 40,
	TLS_KRB5_EXPORT_WITH_DES_CBC_40_MD5 = 41,
	TLS_KRB5_EXPORT_WITH_RC2_CBC_40_MD5 = 42,
	TLS_KRB5_EXPORT_WITH_RC4_40_MD5 = 43,
	TLS_RSA_WITH_AES_128_CBC_SHA = 47,
	TLS_DH_DSS_WITH_AES_128_CBC_SHA = 48,
	TLS_DH_RSA_WITH_AES_128_CBC_SHA = 49,
	TLS_DHE_DSS_WITH_AES_128_CBC_SHA = 50,
	TLS_DHE_RSA_WITH_AES_128_CBC_SHA = 51,
	TLS_DH_ANON_WITH_AES_128_CBC_SHA = 52,
	TLS_RSA_WITH_AES_256_CBC_SHA = 53,
	TLS_DH_DSS_WITH_AES_256_CBC_SHA = 54,
	TLS_DH_RSA_WITH_AES_256_CBC_SHA = 55,
	TLS_DHE_DSS_WITH_AES_256_CBC_SHA = 56,
	TLS_DHE_RSA_WITH_AES_256_CBC_SHA = 57,
	TLS_DH_ANON_WITH_AES_256_CBC_SHA = 58,
	TLS_RSA_WITH_NULL_SHA256 = 59,
	TLS_RSA_WITH_AES_128_CBC_SHA256 = 60,
	TLS_RSA_WITH_AES_256_CBC_SHA256 = 61,
	TLS_DH_DSS_WITH_AES_128_CBC_SHA256 = 62,
	TLS_DH_RSA_WITH_AES_128_CBC_SHA256 = 63,
	TLS_DHE_DSS_WITH_AES_128_CBC_SHA256 = 64,
	TLS_RSA_WITH_CAMELLIA_128_CBC_SHA = 65,
	TLS_DH_DSS_WITH_CAMELLIA_128_CBC_SHA = 66,
	TLS_DH_RSA_WITH_CAMELLIA_128_CBC_SHA = 67,
	TLS_DHE_DSS_WITH_CAMELLIA_128_CBC_SHA = 68,
	TLS_DHE_RSA_WITH_CAMELLIA_128_CBC_SHA = 69,
	TLS_DH_ANON_WITH_CAMELLIA_128_CBC_SHA = 70,
	TLS_RSA_EXPORT1024_WITH_RC4_56_MD5 = 96,
	TLS_RSA_EXPORT1024_WITH_RC2_CBC_56_MD5 = 97,
	TLS_RSA_EXPORT1024_WITH_DES_CBC_SHA = 98,
	TLS_DHE_DSS_EXPORT1024_WITH_DES_CBC_SHA = 99,
	TLS_RSA_EXPORT1024_WITH_RC4_56_SHA = 100,
	TLS_DHE_DSS_EXPORT1024_WITH_RC4_56_SHA = 101,
	TLS_DHE_DSS_WITH_RC4_128_SHA = 102,
	TLS_DHE_RSA_WITH_AES_128_CBC_SHA256 = 103,
	TLS_DH_DSS_WITH_AES_256_CBC_SHA256 = 104,
	TLS_DH_RSA_WITH_AES_256_CBC_SHA256 = 105,
	TLS_DHE_DSS_WITH_AES_256_CBC_SHA256 = 106,
	TLS_DHE_RSA_WITH_AES_256_CBC_SHA256 = 107,
	TLS_DH_ANON_WITH_AES_128_CBC_SHA256 = 108,
	TLS_DH_ANON_WITH_AES_256_CBC_SHA256 = 109,
	TLS_DHE_DSS_WITH_3DES_EDE_CBC_RMD = 114,
	TLS_DHE_DSS_WITH_AES_128_CBC_RMD = 115,
	TLS_DHE_DSS_WITH_AES_256_CBC_RMD = 116,
	TLS_DHE_RSA_WITH_3DES_EDE_CBC_RMD = 119,
	TLS_DHE_RSA_WITH_AES_128_CBC_RMD = 120,
	TLS_DHE_RSA_WITH_AES_256_CBC_RMD = 121,
	TLS_RSA_WITH_3DES_EDE_CBC_RMD = 124,
	TLS_RSA_WITH_AES_128_CBC_RMD = 125,
	TLS_RSA_WITH_AES_256_CBC_RMD = 126,
	TLS_GOSTR341094_WITH_28147_CNT_IMIT = 128,
	TLS_GOSTR341001_WITH_28147_CNT_IMIT = 129,
	TLS_GOSTR341094_WITH_NULL_GOSTR3411 = 130,
	TLS_GOSTR341001_WITH_NULL_GOSTR3411 = 131,
	TLS_RSA_WITH_CAMELLIA_256_CBC_SHA = 132,
	TLS_DH_DSS_WITH_CAMELLIA_256_CBC_SHA = 133,
	TLS_DH_RSA_WITH_CAMELLIA_256_CBC_SHA = 134,
	TLS_DHE_DSS_WITH_CAMELLIA_256_CBC_SHA = 135,
	TLS_DHE_RSA_WITH_CAMELLIA_256_CBC_SHA = 136,
	TLS_DH_ANON_WITH_CAMELLIA_256_CBC_SHA = 137,
	TLS_PSK_WITH_RC4_128_SHA = 138,
	TLS_PSK_WITH_3DES_EDE_CBC_SHA = 139,
	TLS_PSK_WITH_AES_128_CBC_SHA = 140,
	TLS_PSK_WITH_AES_256_CBC_SHA = 141,
	TLS_DHE_PSK_WITH_RC4_128_SHA = 142,
	TLS_DHE_PSK_WITH_3DES_EDE_CBC_SHA = 143,
	TLS_DHE_PSK_WITH_AES_128_CBC_SHA = 144,
	TLS_DHE_PSK_WITH_AES_256_CBC_SHA = 145,
	TLS_RSA_PSK_WITH_RC4_128_SHA = 146,
	TLS_RSA_PSK_WITH_3DES_EDE_CBC_SHA = 147,
	TLS_RSA_PSK_WITH_AES_128_CBC_SHA = 148,
	TLS_RSA_PSK_WITH_AES_256_CBC_SHA = 149,
	TLS_RSA_WITH_SEED_CBC_SHA = 150,
	TLS_DH_DSS_WITH_SEED_CBC_SHA = 151,
	TLS_DH_RSA_WITH_SEED_CBC_SHA = 152,
	TLS_DHE_DSS_WITH_SEED_CBC_SHA = 153,
	TLS_DHE_RSA_WITH_SEED_CBC_SHA = 154,
	TLS_DH_ANON_WITH_SEED_CBC_SHA = 155,
	TLS_RSA_WITH_AES_128_GCM_SHA256 = 156,
	TLS_RSA_WITH_AES_256_GCM_SHA384 = 157,
	TLS_DHE_RSA_WITH_AES_128_GCM_SHA256 = 158,
	TLS_DHE_RSA_WITH_AES_256_GCM_SHA384 = 159,
	TLS_DH_RSA_WITH_AES_128_GCM_SHA256 = 160,
	TLS_DH_RSA_WITH_AES_256_GCM_SHA384 = 161,
	TLS_DHE_DSS_WITH_AES_128_GCM_SHA256 = 162,
	TLS_DHE_DSS_WITH_AES_256_GCM_SHA384 = 163,
	TLS_DH_DSS_WITH_AES_128_GCM_SHA256 = 164,
	TLS_DH_DSS_WITH_AES_256_GCM_SHA384 = 165,
	TLS_DH_ANON_WITH_AES_128_GCM_SHA256 = 166,
	TLS_DH_ANON_WITH_AES_256_GCM_SHA384 = 167,
	TLS_PSK_WITH_AES_128_GCM_SHA256 = 168,
	TLS_PSK_WITH_AES_256_GCM_SHA384 = 169,
	TLS_DHE_PSK_WITH_AES_128_GCM_SHA256 = 170,
	TLS_DHE_PSK_WITH_AES_256_GCM_SHA384 = 171,
	TLS_RSA_PSK_WITH_AES_128_GCM_SHA256 = 172,
	TLS_RSA_PSK_WITH_AES_256_GCM_SHA384 = 173,
	TLS_PSK_WITH_AES_128_CBC_SHA256 = 174,
	TLS_PSK_WITH_AES_256_CBC_SHA384 = 175,
	TLS_PSK_WITH_NULL_SHA256 = 176,
	TLS_PSK_WITH_NULL_SHA384 = 177,
	TLS_DHE_PSK_WITH_AES_128_CBC_SHA256 = 178,
	TLS_DHE_PSK_WITH_AES_256_CBC_SHA384 = 179,
	TLS_DHE_PSK_WITH_NULL_SHA256 = 180,
	TLS_DHE_PSK_WITH_NULL_SHA384 = 181,
	TLS_RSA_PSK_WITH_AES_128_CBC_SHA256 = 182,
	TLS_RSA_PSK_WITH_AES_256_CBC_SHA384 = 183,
	TLS_RSA_PSK_WITH_NULL_SHA256 = 184,
	TLS_RSA_PSK_WITH_NULL_SHA384 = 185,
	TLS_RSA_WITH_CAMELLIA_128_CBC_SHA256 = 186,
	TLS_DH_DSS_WITH_CAMELLIA_128_CBC_SHA256 = 187,
	TLS_DH_RSA_WITH_CAMELLIA_128_CBC_SHA256 = 188,
	TLS_DHE_DSS_WITH_CAMELLIA_128_CBC_SHA256 = 189,
	TLS_DHE_RSA_WITH_CAMELLIA_128_CBC_SHA256 = 190,
	TLS_DH_ANON_WITH_CAMELLIA_128_CBC_SHA256 = 191,
	TLS_RSA_WITH_CAMELLIA_256_CBC_SHA256 = 192,
	TLS_DH_DSS_WITH_CAMELLIA_256_CBC_SHA256 = 193,
	TLS_DH_RSA_WITH_CAMELLIA_256_CBC_SHA256 = 194,
	TLS_DHE_DSS_WITH_CAMELLIA_256_CBC_SHA256 = 195,
	TLS_DHE_RSA_WITH_CAMELLIA_256_CBC_SHA256 = 196,
	TLS_DH_ANON_WITH_CAMELLIA_256_CBC_SHA256 = 197,
	TLS_FALLBACK_SCSV = 22016,
	TLS_ECDH_ECDSA_WITH_NULL_SHA = 49153,
	TLS_ECDH_ECDSA_WITH_RC4_128_SHA = 49154,
	TLS_ECDH_ECDSA_WITH_3DES_EDE_CBC_SHA = 49155,
	TLS_ECDH_ECDSA_WITH_AES_128_CBC_SHA = 49156,
	TLS_ECDH_ECDSA_WITH_AES_256_CBC_SHA = 49157,
	TLS_ECDHE_ECDSA_WITH_NULL_SHA = 49158,
	TLS_ECDHE_ECDSA_WITH_RC4_128_SHA = 49159,
	TLS_ECDHE_ECDSA_WITH_3DES_EDE_CBC_SHA = 49160,
	TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA = 49161,
	TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA = 49162,
	TLS_ECDH_RSA_WITH_NULL_SHA = 49163,
	TLS_ECDH_RSA_WITH_RC4_128_SHA = 49164,
	TLS_ECDH_RSA_WITH_3DES_EDE_CBC_SHA = 49165,
	TLS_ECDH_RSA_WITH_AES_128_CBC_SHA = 49166,
	TLS_ECDH_RSA_WITH_AES_256_CBC_SHA = 49167,
	TLS_ECDHE_RSA_WITH_NULL_SHA = 49168,
	TLS_ECDHE_RSA_WITH_RC4_128_SHA = 49169,
	TLS_ECDHE_RSA_WITH_3DES_EDE_CBC_SHA = 49170,
	TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA = 49171,
	TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA = 49172,
	TLS_ECDH_ANON_WITH_NULL_SHA = 49173,
	TLS_ECDH_ANON_WITH_RC4_128_SHA = 49174,
	TLS_ECDH_ANON_WITH_3DES_EDE_CBC_SHA = 49175,
	TLS_ECDH_ANON_WITH_AES_128_CBC_SHA = 49176,
	TLS_ECDH_ANON_WITH_AES_256_CBC_SHA = 49177,
	TLS_SRP_SHA_WITH_3DES_EDE_CBC_SHA = 49178,
	TLS_SRP_SHA_RSA_WITH_3DES_EDE_CBC_SHA = 49179,
	TLS_SRP_SHA_DSS_WITH_3DES_EDE_CBC_SHA = 49180,
	TLS_SRP_SHA_WITH_AES_128_CBC_SHA = 49181,
	TLS_SRP_SHA_RSA_WITH_AES_128_CBC_SHA = 49182,
	TLS_SRP_SHA_DSS_WITH_AES_128_CBC_SHA = 49183,
	TLS_SRP_SHA_WITH_AES_256_CBC_SHA = 49184,
	TLS_SRP_SHA_RSA_WITH_AES_256_CBC_SHA = 49185,
	TLS_SRP_SHA_DSS_WITH_AES_256_CBC_SHA = 49186,
	TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA256 = 49187,
	TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA384 = 49188,
	TLS_ECDH_ECDSA_WITH_AES_128_CBC_SHA256 = 49189,
	TLS_ECDH_ECDSA_WITH_AES_256_CBC_SHA384 = 49190,
	TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA256 = 49191,
	TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384 = 49192,
	TLS_ECDH_RSA_WITH_AES_128_CBC_SHA256 = 49193,
	TLS_ECDH_RSA_WITH_AES_256_CBC_SHA384 = 49194,
	TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256 = 49195,
	TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384 = 49196,
	TLS_ECDH_ECDSA_WITH_AES_128_GCM_SHA256 = 49197,
	TLS_ECDH_ECDSA_WITH_AES_256_GCM_SHA384 = 49198,
	TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256 = 49199,
	TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384 = 49200,
	TLS_ECDH_RSA_WITH_AES_128_GCM_SHA256 = 49201,
	TLS_ECDH_RSA_WITH_AES_256_GCM_SHA384 = 49202,
	TLS_ECDHE_PSK_WITH_RC4_128_SHA = 49203,
	TLS_ECDHE_PSK_WITH_3DES_EDE_CBC_SHA = 49204,
	TLS_ECDHE_PSK_WITH_AES_128_CBC_SHA = 49205,
	TLS_ECDHE_PSK_WITH_AES_256_CBC_SHA = 49206,
	TLS_ECDHE_PSK_WITH_AES_128_CBC_SHA256 = 49207,
	TLS_ECDHE_PSK_WITH_AES_256_CBC_SHA384 = 49208,
	TLS_ECDHE_PSK_WITH_NULL_SHA = 49209,
	TLS_ECDHE_PSK_WITH_NULL_SHA256 = 49210,
	TLS_ECDHE_PSK_WITH_NULL_SHA384 = 49211,
	TLS_RSA_WITH_ARIA_128_CBC_SHA256 = 49212,
	TLS_RSA_WITH_ARIA_256_CBC_SHA384 = 49213,
	TLS_DH_DSS_WITH_ARIA_128_CBC_SHA256 = 49214,
	TLS_DH_DSS_WITH_ARIA_256_CBC_SHA384 = 49215,
	TLS_DH_RSA_WITH_ARIA_128_CBC_SHA256 = 49216,
	TLS_DH_RSA_WITH_ARIA_256_CBC_SHA384 = 49217,
	TLS_DHE_DSS_WITH_ARIA_128_CBC_SHA256 = 49218,
	TLS_DHE_DSS_WITH_ARIA_256_CBC_SHA384 = 49219,
	TLS_DHE_RSA_WITH_ARIA_128_CBC_SHA256 = 49220,
	TLS_DHE_RSA_WITH_ARIA_256_CBC_SHA384 = 49221,
	TLS_DH_ANON_WITH_ARIA_128_CBC_SHA256 = 49222,
	TLS_DH_ANON_WITH_ARIA_256_CBC_SHA384 = 49223,
	TLS_ECDHE_ECDSA_WITH_ARIA_128_CBC_SHA256 = 49224,
	TLS_ECDHE_ECDSA_WITH_ARIA_256_CBC_SHA384 = 49225,
	TLS_ECDH_ECDSA_WITH_ARIA_128_CBC_SHA256 = 49226,
	TLS_ECDH_ECDSA_WITH_ARIA_256_CBC_SHA384 = 49227,
	TLS_ECDHE_RSA_WITH_ARIA_128_CBC_SHA256 = 49228,
	TLS_ECDHE_RSA_WITH_ARIA_256_CBC_SHA384 = 49229,
	TLS_ECDH_RSA_WITH_ARIA_128_CBC_SHA256 = 49230,
	TLS_ECDH_RSA_WITH_ARIA_256_CBC_SHA384 = 49231,
	TLS_RSA_WITH_ARIA_128_GCM_SHA256 = 49232,
	TLS_RSA_WITH_ARIA_256_GCM_SHA384 = 49233,
	TLS_DHE_RSA_WITH_ARIA_128_GCM_SHA256 = 49234,
	TLS_DHE_RSA_WITH_ARIA_256_GCM_SHA384 = 49235,
	TLS_DH_RSA_WITH_ARIA_128_GCM_SHA256 = 49236,
	TLS_DH_RSA_WITH_ARIA_256_GCM_SHA384 = 49237,
	TLS_DHE_DSS_WITH_ARIA_128_GCM_SHA256 = 49238,
	TLS_DHE_DSS_WITH_ARIA_256_GCM_SHA384 = 49239,
	TLS_DH_DSS_WITH_ARIA_128_GCM_SHA256 = 49240,
	TLS_DH_DSS_WITH_ARIA_256_GCM_SHA384 = 49241,
	TLS_DH_ANON_WITH_ARIA_128_GCM_SHA256 = 49242,
	TLS_DH_ANON_WITH_ARIA_256_GCM_SHA384 = 49243,
	TLS_ECDHE_ECDSA_WITH_ARIA_128_GCM_SHA256 = 49244,
	TLS_ECDHE_ECDSA_WITH_ARIA_256_GCM_SHA384 = 49245,
	TLS_ECDH_ECDSA_WITH_ARIA_128_GCM_SHA256 = 49246,
	TLS_ECDH_ECDSA_WITH_ARIA_256_GCM_SHA384 = 49247,
	TLS_ECDHE_RSA_WITH_ARIA_128_GCM_SHA256 = 49248,
	TLS_ECDHE_RSA_WITH_ARIA_256_GCM_SHA384 = 49249,
	TLS_ECDH_RSA_WITH_ARIA_128_GCM_SHA256 = 49250,
	TLS_ECDH_RSA_WITH_ARIA_256_GCM_SHA384 = 49251,
	TLS_PSK_WITH_ARIA_128_CBC_SHA256 = 49252,
	TLS_PSK_WITH_ARIA_256_CBC_SHA384 = 49253,
	TLS_DHE_PSK_WITH_ARIA_128_CBC_SHA256 = 49254,
	TLS_DHE_PSK_WITH_ARIA_256_CBC_SHA384 = 49255,
	TLS_RSA_PSK_WITH_ARIA_128_CBC_SHA256 = 49256,
	TLS_RSA_PSK_WITH_ARIA_256_CBC_SHA384 = 49257,
	TLS_PSK_WITH_ARIA_128_GCM_SHA256 = 49258,
	TLS_PSK_WITH_ARIA_256_GCM_SHA384 = 49259,
	TLS_DHE_PSK_WITH_ARIA_128_GCM_SHA256 = 49260,
	TLS_DHE_PSK_WITH_ARIA_256_GCM_SHA384 = 49261,
	TLS_RSA_PSK_WITH_ARIA_128_GCM_SHA256 = 49262,
	TLS_RSA_PSK_WITH_ARIA_256_GCM_SHA384 = 49263,
	TLS_ECDHE_PSK_WITH_ARIA_128_CBC_SHA256 = 49264,
	TLS_ECDHE_PSK_WITH_ARIA_256_CBC_SHA384 = 49265,
	TLS_ECDHE_ECDSA_WITH_CAMELLIA_128_CBC_SHA256 = 49266,
	TLS_ECDHE_ECDSA_WITH_CAMELLIA_256_CBC_SHA384 = 49267,
	TLS_ECDH_ECDSA_WITH_CAMELLIA_128_CBC_SHA256 = 49268,
	TLS_ECDH_ECDSA_WITH_CAMELLIA_256_CBC_SHA384 = 49269,
	TLS_ECDHE_RSA_WITH_CAMELLIA_128_CBC_SHA256 = 49270,
	TLS_ECDHE_RSA_WITH_CAMELLIA_256_CBC_SHA384 = 49271,
	TLS_ECDH_RSA_WITH_CAMELLIA_128_CBC_SHA256 = 49272,
	TLS_ECDH_RSA_WITH_CAMELLIA_256_CBC_SHA384 = 49273,
	TLS_RSA_WITH_CAMELLIA_128_GCM_SHA256 = 49274,
	TLS_RSA_WITH_CAMELLIA_256_GCM_SHA384 = 49275,
	TLS_DHE_RSA_WITH_CAMELLIA_128_GCM_SHA256 = 49276,
	TLS_DHE_RSA_WITH_CAMELLIA_256_GCM_SHA384 = 49277,
	TLS_DH_RSA_WITH_CAMELLIA_128_GCM_SHA256 = 49278,
	TLS_DH_RSA_WITH_CAMELLIA_256_GCM_SHA384 = 49279,
	TLS_DHE_DSS_WITH_CAMELLIA_128_GCM_SHA256 = 49280,
	TLS_DHE_DSS_WITH_CAMELLIA_256_GCM_SHA384 = 49281,
	TLS_DH_DSS_WITH_CAMELLIA_128_GCM_SHA256 = 49282,
	TLS_DH_DSS_WITH_CAMELLIA_256_GCM_SHA384 = 49283,
	TLS_DH_ANON_WITH_CAMELLIA_128_GCM_SHA256 = 49284,
	TLS_DH_ANON_WITH_CAMELLIA_256_GCM_SHA384 = 49285,
	TLS_ECDHE_ECDSA_WITH_CAMELLIA_128_GCM_SHA256 = 49286,
	TLS_ECDHE_ECDSA_WITH_CAMELLIA_256_GCM_SHA384 = 49287,
	TLS_ECDH_ECDSA_WITH_CAMELLIA_128_GCM_SHA256 = 49288,
	TLS_ECDH_ECDSA_WITH_CAMELLIA_256_GCM_SHA384 = 49289,
	TLS_ECDHE_RSA_WITH_CAMELLIA_128_GCM_SHA256 = 49290,
	TLS_ECDHE_RSA_WITH_CAMELLIA_256_GCM_SHA384 = 49291,
	TLS_ECDH_RSA_WITH_CAMELLIA_128_GCM_SHA256 = 49292,
	TLS_ECDH_RSA_WITH_CAMELLIA_256_GCM_SHA384 = 49293,
	TLS_PSK_WITH_CAMELLIA_128_GCM_SHA256 = 49294,
	TLS_PSK_WITH_CAMELLIA_256_GCM_SHA384 = 49295,
	TLS_DHE_PSK_WITH_CAMELLIA_128_GCM_SHA256 = 49296,
	TLS_DHE_PSK_WITH_CAMELLIA_256_GCM_SHA384 = 49297,
	TLS_RSA_PSK_WITH_CAMELLIA_128_GCM_SHA256 = 49298,
	TLS_RSA_PSK_WITH_CAMELLIA_256_GCM_SHA384 = 49299,
	TLS_PSK_WITH_CAMELLIA_128_CBC_SHA256 = 49300,
	TLS_PSK_WITH_CAMELLIA_256_CBC_SHA384 = 49301,
	TLS_DHE_PSK_WITH_CAMELLIA_128_CBC_SHA256 = 49302,
	TLS_DHE_PSK_WITH_CAMELLIA_256_CBC_SHA384 = 49303,
	TLS_RSA_PSK_WITH_CAMELLIA_128_CBC_SHA256 = 49304,
	TLS_RSA_PSK_WITH_CAMELLIA_256_CBC_SHA384 = 49305,
	TLS_ECDHE_PSK_WITH_CAMELLIA_128_CBC_SHA256 = 49306,
	TLS_ECDHE_PSK_WITH_CAMELLIA_256_CBC_SHA384 = 49307,
	TLS_RSA_WITH_AES_128_CCM = 49308,
	TLS_RSA_WITH_AES_256_CCM = 49309,
	TLS_DHE_RSA_WITH_AES_128_CCM = 49310,
	TLS_DHE_RSA_WITH_AES_256_CCM = 49311,
	TLS_RSA_WITH_AES_128_CCM_8 = 49312,
	TLS_RSA_WITH_AES_256_CCM_8 = 49313,
	TLS_DHE_RSA_WITH_AES_128_CCM_8 = 49314,
	TLS_DHE_RSA_WITH_AES_256_CCM_8 = 49315,
	TLS_PSK_WITH_AES_128_CCM = 49316,
	TLS_PSK_WITH_AES_256_CCM = 49317,
	TLS_DHE_PSK_WITH_AES_128_CCM = 49318,
	TLS_DHE_PSK_WITH_AES_256_CCM = 49319,
	TLS_PSK_WITH_AES_128_CCM_8 = 49320,
	TLS_PSK_WITH_AES_256_CCM_8 = 49321,
	TLS_PSK_DHE_WITH_AES_128_CCM_8 = 49322,
	TLS_PSK_DHE_WITH_AES_256_CCM_8 = 49323,
	TLS_ECDHE_ECDSA_WITH_AES_128_CCM = 49324,
	TLS_ECDHE_ECDSA_WITH_AES_256_CCM = 49325,
	TLS_ECDHE_ECDSA_WITH_AES_128_CCM_8 = 49326,
	TLS_ECDHE_ECDSA_WITH_AES_256_CCM_8 = 49327,
	TLS_ECDHE_RSA_WITH_CHACHA20_POLY1305_SHA256 = 52243,
	TLS_ECDHE_ECDSA_WITH_CHACHA20_POLY1305_SHA256 = 52244,
	TLS_DHE_RSA_WITH_CHACHA20_POLY1305_SHA256 = 52245,
};
enum HandshakeType {
	HELLO_REQUEST = 0,
	CLIENT_HELLO = 1,
	SERVER_HELLO = 2,
	HELLO_VERIFY_REQUEST = 3,
	SESSION_TICKET = 4,
	CERTIFICATE = 11,
	SERVER_KEY_EXCHANGE = 12,
	CERTIFICATE_REQUEST = 13,
	SERVER_HELLO_DONE = 14,
	CERTIFICATE_VERIFY = 15,
	CLIENT_KEY_EXCHANGE = 16,
	FINISHED = 20,
	CERTIFICATE_URL = 21,
	CERTIFICATE_STATUS = 22,
};
class HandshakeRecord;
class Handshake;
class HandshakePDU;
class UnknownHandshake;
class HelloRequest;
class ClientHello;
class ClientHelloCookie;
class ServerHello;
class HelloVerifyRequest;
class X509Certificate;
class Certificate;
class CertificateStatus;
class ServerKeyExchange;
class EcServerKeyExchange;
class DhServerKeyExchange;
class CertificateRequest;
class ServerHelloDone;
class ClientKeyExchange;
class CertificateVerify;
class Finished;
class SessionTicketHandshake;
class SSLExtension;
class ServerNameHostName;
class ServerName;
class ServerNameExt;
class EcPointFormats;
class EllipticCurves;
class ProtocolName;
class ApplicationLayerProtocolNegotiationExtension;
class Handshake_Flow;
} // namespace TLSHandshake

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
namespace TLSHandshake {

class ContextTLSHandshake
{
public:
	ContextTLSHandshake(Handshake_Conn * connection, Handshake_Flow * flow, FlowBuffer * flow_buffer);
	~ContextTLSHandshake();
	
	// Member access functions
	Handshake_Conn * connection() const { return connection_; }
	Handshake_Flow * flow() const { return flow_; }
	FlowBuffer * flow_buffer() const { return flow_buffer_; }
	
protected:
	Handshake_Conn * connection_;
	Handshake_Flow * flow_;
	FlowBuffer * flow_buffer_;
};


class Handshake_Conn : public binpac::ConnectionAnalyzer
{
public:
	Handshake_Conn(BroAnalyzer const & bro_analyzer);
	~Handshake_Conn();
	
	// Member access functions
	Handshake_Flow * upflow() const { return upflow_; }
	Handshake_Flow * downflow() const { return downflow_; }
	BroAnalyzer const & bro_analyzer() const { return bro_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
	// Functions
	int chosen_cipher();
	bool set_cipher(uint32 cipher);
	bool proc_client_hello(uint16 version, double ts, bytestring const & client_random, vector<uint8> * session_id, vector<uint16> * cipher_suites16, vector<uint24 *> * cipher_suites24);
	bool proc_server_hello(uint16 version, double ts, bytestring const & server_random, vector<uint8> * session_id, vector<uint16> * cipher_suites16, vector<uint24 *> * cipher_suites24, uint8 comp_method);
	bool proc_certificate(bool is_orig, vector<bytestring> * certificates);
	bool proc_session_ticket_handshake(SessionTicketHandshake * rec, bool is_orig);
	bool proc_ssl_extension(HandshakeRecord * rec, int type, const_bytestring const & sourcedata);
	bool proc_ec_point_formats(HandshakeRecord * rec, vector<uint8> * point_format_list);
	bool proc_elliptic_curves(HandshakeRecord * rec, vector<uint16> * list);
	bool proc_apnl(HandshakeRecord * rec, vector<ProtocolName *> * protocols);
	bool proc_server_name(HandshakeRecord * rec, vector<ServerName *> * list);
	bool proc_v3_certificate(bool is_orig, vector<X509Certificate *> * cl);
	bool proc_unknown_handshake(HandshakeRecord * hs, bool is_orig);
	bool proc_certificate_status(HandshakeRecord * rec, uint8 status_type, bytestring const & response);
	bool proc_ec_server_key_exchange(HandshakeRecord * rec, uint8 curve_type, uint16 curve);
	bool proc_dh_server_key_exchange(HandshakeRecord * rec, bytestring const & p, bytestring const & g, bytestring const & Ys);
	bool proc_handshake(bool is_orig, uint8 msg_type, uint24 * length);
	
protected:
	
	// Additional members

		uint32 chosen_cipher_;
	
	Handshake_Flow * upflow_;
	Handshake_Flow * downflow_;
	BroAnalyzer bro_analyzer_;
};


class uint24
{
public:
	uint24();
	~uint24();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 byte1() const { return byte1_; }
	uint8 byte2() const { return byte2_; }
	uint8 byte3() const { return byte3_; }
	
protected:
	uint8 byte1_;
	uint8 byte2_;
	uint8 byte3_;
};


class uint48
{
public:
	uint48();
	~uint48();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 byte1() const { return byte1_; }
	uint8 byte2() const { return byte2_; }
	uint8 byte3() const { return byte3_; }
	uint8 byte4() const { return byte4_; }
	uint8 byte5() const { return byte5_; }
	uint8 byte6() const { return byte6_; }
	
protected:
	uint8 byte1_;
	uint8 byte2_;
	uint8 byte3_;
	uint8 byte4_;
	uint8 byte5_;
	uint8 byte6_;
};


	string orig_label(bool is_orig);
	

	class to_int {
	public:
		int operator()(uint24 * num) const
		{
		return (num->byte1() << 16) | (num->byte2() << 8) | num->byte3();
		}

		uint64 operator()(uint48 * num) const
		{
		return ((uint64)num->byte1() << 40) | ((uint64)num->byte2() << 32) | ((uint64)num->byte3() << 24) |
		  ((uint64)num->byte4() << 16) | ((uint64)num->byte5() << 8) | (uint64)num->byte6();
		}
	};

	string state_label(int state_nr);

StringVal * to_string_val(vector<uint8> * data);
bool version_ok(uint16 vers);
extern uint32 const MAX_DTLS_HANDSHAKE_RECORD;

class HandshakeRecord
{
public:
	HandshakeRecord(bool is_orig);
	~HandshakeRecord();
	int initial_buffer_length() const { return 4; }
	bool ParseBuffer(flow_buffer_t t_flow_buffer, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint8 msg_type() const { return msg_type_; }
	uint24 * msg_length() const { return msg_length_; }
	Handshake * rec() const { return rec_; }
	bool is_orig() const { return is_orig_; }
	
protected:
	uint8 msg_type_;
	uint24 * msg_length_;
	Handshake * rec_;
	bool is_orig_;
	int buffering_state_;
};


class Handshake
{
public:
	Handshake(HandshakeRecord * rec);
	~Handshake();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	HelloRequest * hello_request() const
		{
		switch ( val_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:34:hello_request", val_case_index(), "HELLO_REQUEST");
				break;
			}
		return hello_request_;
		}
	ClientHello * client_hello() const
		{
		switch ( val_case_index() )
			{
			case 1:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:35:client_hello", val_case_index(), "CLIENT_HELLO");
				break;
			}
		return client_hello_;
		}
	ServerHello * server_hello() const
		{
		switch ( val_case_index() )
			{
			case 2:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:36:server_hello", val_case_index(), "SERVER_HELLO");
				break;
			}
		return server_hello_;
		}
	HelloVerifyRequest * hello_verify_request() const
		{
		switch ( val_case_index() )
			{
			case 3:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:37:hello_verify_request", val_case_index(), "HELLO_VERIFY_REQUEST");
				break;
			}
		return hello_verify_request_;
		}
	SessionTicketHandshake * session_ticket() const
		{
		switch ( val_case_index() )
			{
			case 4:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:38:session_ticket", val_case_index(), "SESSION_TICKET");
				break;
			}
		return session_ticket_;
		}
	Certificate * certificate() const
		{
		switch ( val_case_index() )
			{
			case 11:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:39:certificate", val_case_index(), "CERTIFICATE");
				break;
			}
		return certificate_;
		}
	ServerKeyExchange * server_key_exchange() const
		{
		switch ( val_case_index() )
			{
			case 12:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:40:server_key_exchange", val_case_index(), "SERVER_KEY_EXCHANGE");
				break;
			}
		return server_key_exchange_;
		}
	CertificateRequest * certificate_request() const
		{
		switch ( val_case_index() )
			{
			case 13:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:41:certificate_request", val_case_index(), "CERTIFICATE_REQUEST");
				break;
			}
		return certificate_request_;
		}
	ServerHelloDone * server_hello_done() const
		{
		switch ( val_case_index() )
			{
			case 14:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:42:server_hello_done", val_case_index(), "SERVER_HELLO_DONE");
				break;
			}
		return server_hello_done_;
		}
	CertificateVerify * certificate_verify() const
		{
		switch ( val_case_index() )
			{
			case 15:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:43:certificate_verify", val_case_index(), "CERTIFICATE_VERIFY");
				break;
			}
		return certificate_verify_;
		}
	ClientKeyExchange * client_key_exchange() const
		{
		switch ( val_case_index() )
			{
			case 16:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:44:client_key_exchange", val_case_index(), "CLIENT_KEY_EXCHANGE");
				break;
			}
		return client_key_exchange_;
		}
	Finished * finished() const
		{
		switch ( val_case_index() )
			{
			case 20:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:45:finished", val_case_index(), "FINISHED");
				break;
			}
		return finished_;
		}
	CertificateStatus * certificate_status() const
		{
		switch ( val_case_index() )
			{
			case 22:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:47:certificate_status", val_case_index(), "CERTIFICATE_STATUS");
				break;
			}
		return certificate_status_;
		}
	UnknownHandshake * unknown_handshake() const
		{
		return unknown_handshake_;
		}
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	int val_case_index_;
	HelloRequest * hello_request_;
	ClientHello * client_hello_;
	ServerHello * server_hello_;
	HelloVerifyRequest * hello_verify_request_;
	SessionTicketHandshake * session_ticket_;
	Certificate * certificate_;
	ServerKeyExchange * server_key_exchange_;
	CertificateRequest * certificate_request_;
	ServerHelloDone * server_hello_done_;
	CertificateVerify * certificate_verify_;
	ClientKeyExchange * client_key_exchange_;
	Finished * finished_;
	const_bytestring certificate_url_;
	CertificateStatus * certificate_status_;
	UnknownHandshake * unknown_handshake_;
	HandshakeRecord * rec_;
	bool proc_;
};


class HandshakePDU
{
public:
	HandshakePDU(bool is_orig);
	~HandshakePDU();
	bool ParseBuffer(flow_buffer_t t_flow_buffer, ContextTLSHandshake * t_context);
	
	// Member access functions
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	
protected:
	vector<HandshakeRecord *> * records_;
	HandshakeRecord * records__elem_;
	int records__arraylength_;
	int records__elem__it_;
	bool is_orig_;
	int byteorder_;
	int parsing_state_;
};


class UnknownHandshake
{
public:
	UnknownHandshake(HandshakeRecord * hs, bool is_orig);
	~UnknownHandshake();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	HandshakeRecord * hs() const { return hs_; }
	bool is_orig() const { return is_orig_; }
	bool proc() const { return proc_; }
	
protected:
	const_bytestring data_;
	HandshakeRecord * hs_;
	bool is_orig_;
	bool proc_;
};


class HelloRequest
{
public:
	HelloRequest(HandshakeRecord * rec);
	~HelloRequest();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	HandshakeRecord * rec_;
};


class ClientHello
{
public:
	ClientHello(HandshakeRecord * rec);
	~ClientHello();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint16 client_version() const { return client_version_; }
	uint32 gmt_unix_time() const { return gmt_unix_time_; }
	bytestring const & random_bytes() const { return random_bytes_; }
	uint8 session_len() const { return session_len_; }
	vector<uint8> * session_id() const { return session_id_; }
	int dtls_cookie_case_index() const	{ return dtls_cookie_case_index_; }
	ClientHelloCookie * cookie() const
		{
		switch ( dtls_cookie_case_index() )
			{
			case 65279:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:78:cookie", dtls_cookie_case_index(), "DTLSv10");
				break;
			}
		return cookie_;
		}
	bytestring const & nothing() const
		{
		return nothing_;
		}
	uint16 csuit_len() const { return csuit_len_; }
	vector<uint16> * csuits() const { return csuits_; }
	uint8 cmeth_len() const { return cmeth_len_; }
	vector<uint8> * cmeths() const { return cmeths_; }
	vector<uint16> * ext_len() const { return ext_len_; }
	vector<SSLExtension *> * extensions() const { return extensions_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint16 client_version_;
	uint32 gmt_unix_time_;
	bytestring random_bytes_;
	uint8 session_len_;
	vector<uint8> * session_id_;
	uint8 session_id__elem_;
	int dtls_cookie_case_index_;
	ClientHelloCookie * cookie_;
	bytestring nothing_;
	uint16 csuit_len_;
	vector<uint16> * csuits_;
	uint16 csuits__elem_;
	uint8 cmeth_len_;
	vector<uint8> * cmeths_;
	uint8 cmeths__elem_;
	vector<uint16> * ext_len_;
	uint16 ext_len__elem_;
	vector<SSLExtension *> * extensions_;
	SSLExtension * extensions__elem_;
	HandshakeRecord * rec_;
	bool proc_;
};


class ClientHelloCookie
{
public:
	ClientHelloCookie(HandshakeRecord * rec);
	~ClientHelloCookie();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	uint8 cookie_len() const { return cookie_len_; }
	bytestring const & cookie() const { return cookie_; }
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	uint8 cookie_len_;
	bytestring cookie_;
	HandshakeRecord * rec_;
};


class ServerHello
{
public:
	ServerHello(HandshakeRecord * rec);
	~ServerHello();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint16 server_version() const { return server_version_; }
	uint32 gmt_unix_time() const { return gmt_unix_time_; }
	bytestring const & random_bytes() const { return random_bytes_; }
	uint8 session_len() const { return session_len_; }
	vector<uint8> * session_id() const { return session_id_; }
	vector<uint16> * cipher_suite() const { return cipher_suite_; }
	uint8 compression_method() const { return compression_method_; }
	vector<uint16> * ext_len() const { return ext_len_; }
	vector<SSLExtension *> * extensions() const { return extensions_; }
	HandshakeRecord * rec() const { return rec_; }
	bool cipher_set() const { return cipher_set_; }
	bool proc() const { return proc_; }
	
protected:
	uint16 server_version_;
	uint32 gmt_unix_time_;
	bytestring random_bytes_;
	uint8 session_len_;
	vector<uint8> * session_id_;
	uint8 session_id__elem_;
	vector<uint16> * cipher_suite_;
	uint16 cipher_suite__elem_;
	uint8 compression_method_;
	vector<uint16> * ext_len_;
	uint16 ext_len__elem_;
	vector<SSLExtension *> * extensions_;
	SSLExtension * extensions__elem_;
	HandshakeRecord * rec_;
	bool cipher_set_;
	bool proc_;
};


class HelloVerifyRequest
{
public:
	HelloVerifyRequest(HandshakeRecord * rec);
	~HelloVerifyRequest();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint16 version() const { return version_; }
	uint8 cookie_length() const { return cookie_length_; }
	bytestring const & cookie() const { return cookie_; }
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	uint16 version_;
	uint8 cookie_length_;
	bytestring cookie_;
	HandshakeRecord * rec_;
};


class X509Certificate
{
public:
	X509Certificate();
	~X509Certificate();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint24 * length() const { return length_; }
	bytestring const & certificate() const { return certificate_; }
	
protected:
	uint24 * length_;
	bytestring certificate_;
};


class Certificate
{
public:
	Certificate(HandshakeRecord * rec);
	~Certificate();
	int initial_buffer_length() const { return 3; }
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	uint24 * length() const { return length_; }
	vector<X509Certificate *> * certificates() const { return certificates_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint24 * length_;
	vector<X509Certificate *> * certificates_;
	X509Certificate * certificates__elem_;
	HandshakeRecord * rec_;
	bool proc_;
};


class CertificateStatus
{
public:
	CertificateStatus(HandshakeRecord * rec);
	~CertificateStatus();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	uint8 status_type() const { return status_type_; }
	uint24 * length() const { return length_; }
	bytestring const & response() const { return response_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint8 status_type_;
	uint24 * length_;
	bytestring response_;
	HandshakeRecord * rec_;
	bool proc_;
};


class ServerKeyExchange
{
public:
	ServerKeyExchange(HandshakeRecord * rec);
	~ServerKeyExchange();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	int val_case_index() const	{ return val_case_index_; }
	EcServerKeyExchange * ec_server_key_exchange() const
		{
		switch ( val_case_index() )
			{
			case 49153:
			case 49154:
			case 49155:
			case 49156:
			case 49157:
			case 49158:
			case 49159:
			case 49160:
			case 49161:
			case 49162:
			case 49163:
			case 49164:
			case 49165:
			case 49166:
			case 49167:
			case 49168:
			case 49169:
			case 49170:
			case 49171:
			case 49172:
			case 49173:
			case 49174:
			case 49175:
			case 49176:
			case 49177:
			case 49187:
			case 49188:
			case 49189:
			case 49190:
			case 49191:
			case 49192:
			case 49193:
			case 49194:
			case 49195:
			case 49196:
			case 49197:
			case 49198:
			case 49199:
			case 49200:
			case 49201:
			case 49202:
			case 49203:
			case 49204:
			case 49205:
			case 49206:
			case 49207:
			case 49208:
			case 49209:
			case 49210:
			case 49211:
			case 49224:
			case 49225:
			case 49226:
			case 49227:
			case 49228:
			case 49229:
			case 49230:
			case 49231:
			case 49244:
			case 49245:
			case 49246:
			case 49247:
			case 49248:
			case 49249:
			case 49250:
			case 49251:
			case 49264:
			case 49265:
			case 49266:
			case 49267:
			case 49268:
			case 49269:
			case 49270:
			case 49271:
			case 49272:
			case 49273:
			case 49286:
			case 49287:
			case 49288:
			case 49289:
			case 49290:
			case 49291:
			case 49292:
			case 49293:
			case 49306:
			case 49307:
			case 49324:
			case 49325:
			case 49326:
			case 49327:
			case 52243:
			case 52244:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:252:ec_server_key_exchange", val_case_index(), "TLS_ECDH_ECDSA_WITH_NULL_SHA, TLS_ECDH_ECDSA_WITH_RC4_128_SHA, TLS_ECDH_ECDSA_WITH_3DES_EDE_CBC_SHA, TLS_ECDH_ECDSA_WITH_AES_128_CBC_SHA, TLS_ECDH_ECDSA_WITH_AES_256_CBC_SHA, TLS_ECDHE_ECDSA_WITH_NULL_SHA, TLS_ECDHE_ECDSA_WITH_RC4_128_SHA, TLS_ECDHE_ECDSA_WITH_3DES_EDE_CBC_SHA, TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA, TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA, TLS_ECDH_RSA_WITH_NULL_SHA, TLS_ECDH_RSA_WITH_RC4_128_SHA, TLS_ECDH_RSA_WITH_3DES_EDE_CBC_SHA, TLS_ECDH_RSA_WITH_AES_128_CBC_SHA, TLS_ECDH_RSA_WITH_AES_256_CBC_SHA, TLS_ECDHE_RSA_WITH_NULL_SHA, TLS_ECDHE_RSA_WITH_RC4_128_SHA, TLS_ECDHE_RSA_WITH_3DES_EDE_CBC_SHA, TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA, TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA, TLS_ECDH_ANON_WITH_NULL_SHA, TLS_ECDH_ANON_WITH_RC4_128_SHA, TLS_ECDH_ANON_WITH_3DES_EDE_CBC_SHA, TLS_ECDH_ANON_WITH_AES_128_CBC_SHA, TLS_ECDH_ANON_WITH_AES_256_CBC_SHA, TLS_ECDHE_ECDSA_WITH_AES_128_CBC_SHA256, TLS_ECDHE_ECDSA_WITH_AES_256_CBC_SHA384, TLS_ECDH_ECDSA_WITH_AES_128_CBC_SHA256, TLS_ECDH_ECDSA_WITH_AES_256_CBC_SHA384, TLS_ECDHE_RSA_WITH_AES_128_CBC_SHA256, TLS_ECDHE_RSA_WITH_AES_256_CBC_SHA384, TLS_ECDH_RSA_WITH_AES_128_CBC_SHA256, TLS_ECDH_RSA_WITH_AES_256_CBC_SHA384, TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256, TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384, TLS_ECDH_ECDSA_WITH_AES_128_GCM_SHA256, TLS_ECDH_ECDSA_WITH_AES_256_GCM_SHA384, TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256, TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384, TLS_ECDH_RSA_WITH_AES_128_GCM_SHA256, TLS_ECDH_RSA_WITH_AES_256_GCM_SHA384, TLS_ECDHE_PSK_WITH_RC4_128_SHA, TLS_ECDHE_PSK_WITH_3DES_EDE_CBC_SHA, TLS_ECDHE_PSK_WITH_AES_128_CBC_SHA, TLS_ECDHE_PSK_WITH_AES_256_CBC_SHA, TLS_ECDHE_PSK_WITH_AES_128_CBC_SHA256, TLS_ECDHE_PSK_WITH_AES_256_CBC_SHA384, TLS_ECDHE_PSK_WITH_NULL_SHA, TLS_ECDHE_PSK_WITH_NULL_SHA256, TLS_ECDHE_PSK_WITH_NULL_SHA384, TLS_ECDHE_ECDSA_WITH_ARIA_128_CBC_SHA256, TLS_ECDHE_ECDSA_WITH_ARIA_256_CBC_SHA384, TLS_ECDH_ECDSA_WITH_ARIA_128_CBC_SHA256, TLS_ECDH_ECDSA_WITH_ARIA_256_CBC_SHA384, TLS_ECDHE_RSA_WITH_ARIA_128_CBC_SHA256, TLS_ECDHE_RSA_WITH_ARIA_256_CBC_SHA384, TLS_ECDH_RSA_WITH_ARIA_128_CBC_SHA256, TLS_ECDH_RSA_WITH_ARIA_256_CBC_SHA384, TLS_ECDHE_ECDSA_WITH_ARIA_128_GCM_SHA256, TLS_ECDHE_ECDSA_WITH_ARIA_256_GCM_SHA384, TLS_ECDH_ECDSA_WITH_ARIA_128_GCM_SHA256, TLS_ECDH_ECDSA_WITH_ARIA_256_GCM_SHA384, TLS_ECDHE_RSA_WITH_ARIA_128_GCM_SHA256, TLS_ECDHE_RSA_WITH_ARIA_256_GCM_SHA384, TLS_ECDH_RSA_WITH_ARIA_128_GCM_SHA256, TLS_ECDH_RSA_WITH_ARIA_256_GCM_SHA384, TLS_ECDHE_PSK_WITH_ARIA_128_CBC_SHA256, TLS_ECDHE_PSK_WITH_ARIA_256_CBC_SHA384, TLS_ECDHE_ECDSA_WITH_CAMELLIA_128_CBC_SHA256, TLS_ECDHE_ECDSA_WITH_CAMELLIA_256_CBC_SHA384, TLS_ECDH_ECDSA_WITH_CAMELLIA_128_CBC_SHA256, TLS_ECDH_ECDSA_WITH_CAMELLIA_256_CBC_SHA384, TLS_ECDHE_RSA_WITH_CAMELLIA_128_CBC_SHA256, TLS_ECDHE_RSA_WITH_CAMELLIA_256_CBC_SHA384, TLS_ECDH_RSA_WITH_CAMELLIA_128_CBC_SHA256, TLS_ECDH_RSA_WITH_CAMELLIA_256_CBC_SHA384, TLS_ECDHE_ECDSA_WITH_CAMELLIA_128_GCM_SHA256, TLS_ECDHE_ECDSA_WITH_CAMELLIA_256_GCM_SHA384, TLS_ECDH_ECDSA_WITH_CAMELLIA_128_GCM_SHA256, TLS_ECDH_ECDSA_WITH_CAMELLIA_256_GCM_SHA384, TLS_ECDHE_RSA_WITH_CAMELLIA_128_GCM_SHA256, TLS_ECDHE_RSA_WITH_CAMELLIA_256_GCM_SHA384, TLS_ECDH_RSA_WITH_CAMELLIA_128_GCM_SHA256, TLS_ECDH_RSA_WITH_CAMELLIA_256_GCM_SHA384, TLS_ECDHE_PSK_WITH_CAMELLIA_128_CBC_SHA256, TLS_ECDHE_PSK_WITH_CAMELLIA_256_CBC_SHA384, TLS_ECDHE_ECDSA_WITH_AES_128_CCM, TLS_ECDHE_ECDSA_WITH_AES_256_CCM, TLS_ECDHE_ECDSA_WITH_AES_128_CCM_8, TLS_ECDHE_ECDSA_WITH_AES_256_CCM_8, TLS_ECDHE_RSA_WITH_CHACHA20_POLY1305_SHA256, TLS_ECDHE_ECDSA_WITH_CHACHA20_POLY1305_SHA256");
				break;
			}
		return ec_server_key_exchange_;
		}
	DhServerKeyExchange * dh_server_key_exchange() const
		{
		switch ( val_case_index() )
			{
			case 17:
			case 18:
			case 19:
			case 20:
			case 21:
			case 22:
			case 50:
			case 51:
			case 56:
			case 57:
			case 64:
			case 68:
			case 69:
			case 99:
			case 101:
			case 102:
			case 103:
			case 106:
			case 107:
			case 114:
			case 115:
			case 116:
			case 119:
			case 120:
			case 121:
			case 135:
			case 136:
			case 142:
			case 143:
			case 144:
			case 145:
			case 153:
			case 154:
			case 158:
			case 159:
			case 162:
			case 163:
			case 170:
			case 171:
			case 178:
			case 179:
			case 180:
			case 181:
			case 189:
			case 190:
			case 195:
			case 196:
			case 49218:
			case 49219:
			case 49220:
			case 49221:
			case 49234:
			case 49235:
			case 49238:
			case 49239:
			case 49254:
			case 49255:
			case 49260:
			case 49261:
			case 49276:
			case 49277:
			case 49280:
			case 49281:
			case 49296:
			case 49297:
			case 49302:
			case 49303:
			case 49310:
			case 49311:
			case 49314:
			case 49315:
			case 49318:
			case 49319:
			case 49322:
			case 49323:
			case 52245:
			case 23:
			case 24:
			case 25:
			case 26:
			case 27:
			case 52:
			case 58:
			case 70:
			case 108:
			case 109:
			case 137:
			case 155:
			case 166:
			case 167:
			case 191:
			case 197:
			case 49222:
			case 49223:
			case 49242:
			case 49243:
			case 49284:
			case 49285:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:355:dh_server_key_exchange", val_case_index(), "TLS_DHE_DSS_EXPORT_WITH_DES40_CBC_SHA, TLS_DHE_DSS_WITH_DES_CBC_SHA, TLS_DHE_DSS_WITH_3DES_EDE_CBC_SHA, TLS_DHE_RSA_EXPORT_WITH_DES40_CBC_SHA, TLS_DHE_RSA_WITH_DES_CBC_SHA, TLS_DHE_RSA_WITH_3DES_EDE_CBC_SHA, TLS_DHE_DSS_WITH_AES_128_CBC_SHA, TLS_DHE_RSA_WITH_AES_128_CBC_SHA, TLS_DHE_DSS_WITH_AES_256_CBC_SHA, TLS_DHE_RSA_WITH_AES_256_CBC_SHA, TLS_DHE_DSS_WITH_AES_128_CBC_SHA256, TLS_DHE_DSS_WITH_CAMELLIA_128_CBC_SHA, TLS_DHE_RSA_WITH_CAMELLIA_128_CBC_SHA, TLS_DHE_DSS_EXPORT1024_WITH_DES_CBC_SHA, TLS_DHE_DSS_EXPORT1024_WITH_RC4_56_SHA, TLS_DHE_DSS_WITH_RC4_128_SHA, TLS_DHE_RSA_WITH_AES_128_CBC_SHA256, TLS_DHE_DSS_WITH_AES_256_CBC_SHA256, TLS_DHE_RSA_WITH_AES_256_CBC_SHA256, TLS_DHE_DSS_WITH_3DES_EDE_CBC_RMD, TLS_DHE_DSS_WITH_AES_128_CBC_RMD, TLS_DHE_DSS_WITH_AES_256_CBC_RMD, TLS_DHE_RSA_WITH_3DES_EDE_CBC_RMD, TLS_DHE_RSA_WITH_AES_128_CBC_RMD, TLS_DHE_RSA_WITH_AES_256_CBC_RMD, TLS_DHE_DSS_WITH_CAMELLIA_256_CBC_SHA, TLS_DHE_RSA_WITH_CAMELLIA_256_CBC_SHA, TLS_DHE_PSK_WITH_RC4_128_SHA, TLS_DHE_PSK_WITH_3DES_EDE_CBC_SHA, TLS_DHE_PSK_WITH_AES_128_CBC_SHA, TLS_DHE_PSK_WITH_AES_256_CBC_SHA, TLS_DHE_DSS_WITH_SEED_CBC_SHA, TLS_DHE_RSA_WITH_SEED_CBC_SHA, TLS_DHE_RSA_WITH_AES_128_GCM_SHA256, TLS_DHE_RSA_WITH_AES_256_GCM_SHA384, TLS_DHE_DSS_WITH_AES_128_GCM_SHA256, TLS_DHE_DSS_WITH_AES_256_GCM_SHA384, TLS_DHE_PSK_WITH_AES_128_GCM_SHA256, TLS_DHE_PSK_WITH_AES_256_GCM_SHA384, TLS_DHE_PSK_WITH_AES_128_CBC_SHA256, TLS_DHE_PSK_WITH_AES_256_CBC_SHA384, TLS_DHE_PSK_WITH_NULL_SHA256, TLS_DHE_PSK_WITH_NULL_SHA384, TLS_DHE_DSS_WITH_CAMELLIA_128_CBC_SHA256, TLS_DHE_RSA_WITH_CAMELLIA_128_CBC_SHA256, TLS_DHE_DSS_WITH_CAMELLIA_256_CBC_SHA256, TLS_DHE_RSA_WITH_CAMELLIA_256_CBC_SHA256, TLS_DHE_DSS_WITH_ARIA_128_CBC_SHA256, TLS_DHE_DSS_WITH_ARIA_256_CBC_SHA384, TLS_DHE_RSA_WITH_ARIA_128_CBC_SHA256, TLS_DHE_RSA_WITH_ARIA_256_CBC_SHA384, TLS_DHE_RSA_WITH_ARIA_128_GCM_SHA256, TLS_DHE_RSA_WITH_ARIA_256_GCM_SHA384, TLS_DHE_DSS_WITH_ARIA_128_GCM_SHA256, TLS_DHE_DSS_WITH_ARIA_256_GCM_SHA384, TLS_DHE_PSK_WITH_ARIA_128_CBC_SHA256, TLS_DHE_PSK_WITH_ARIA_256_CBC_SHA384, TLS_DHE_PSK_WITH_ARIA_128_GCM_SHA256, TLS_DHE_PSK_WITH_ARIA_256_GCM_SHA384, TLS_DHE_RSA_WITH_CAMELLIA_128_GCM_SHA256, TLS_DHE_RSA_WITH_CAMELLIA_256_GCM_SHA384, TLS_DHE_DSS_WITH_CAMELLIA_128_GCM_SHA256, TLS_DHE_DSS_WITH_CAMELLIA_256_GCM_SHA384, TLS_DHE_PSK_WITH_CAMELLIA_128_GCM_SHA256, TLS_DHE_PSK_WITH_CAMELLIA_256_GCM_SHA384, TLS_DHE_PSK_WITH_CAMELLIA_128_CBC_SHA256, TLS_DHE_PSK_WITH_CAMELLIA_256_CBC_SHA384, TLS_DHE_RSA_WITH_AES_128_CCM, TLS_DHE_RSA_WITH_AES_256_CCM, TLS_DHE_RSA_WITH_AES_128_CCM_8, TLS_DHE_RSA_WITH_AES_256_CCM_8, TLS_DHE_PSK_WITH_AES_128_CCM, TLS_DHE_PSK_WITH_AES_256_CCM, TLS_PSK_DHE_WITH_AES_128_CCM_8, TLS_PSK_DHE_WITH_AES_256_CCM_8, TLS_DHE_RSA_WITH_CHACHA20_POLY1305_SHA256, TLS_DH_ANON_EXPORT_WITH_RC4_40_MD5, TLS_DH_ANON_WITH_RC4_128_MD5, TLS_DH_ANON_EXPORT_WITH_DES40_CBC_SHA, TLS_DH_ANON_WITH_DES_CBC_SHA, TLS_DH_ANON_WITH_3DES_EDE_CBC_SHA, TLS_DH_ANON_WITH_AES_128_CBC_SHA, TLS_DH_ANON_WITH_AES_256_CBC_SHA, TLS_DH_ANON_WITH_CAMELLIA_128_CBC_SHA, TLS_DH_ANON_WITH_AES_128_CBC_SHA256, TLS_DH_ANON_WITH_AES_256_CBC_SHA256, TLS_DH_ANON_WITH_CAMELLIA_256_CBC_SHA, TLS_DH_ANON_WITH_SEED_CBC_SHA, TLS_DH_ANON_WITH_AES_128_GCM_SHA256, TLS_DH_ANON_WITH_AES_256_GCM_SHA384, TLS_DH_ANON_WITH_CAMELLIA_128_CBC_SHA256, TLS_DH_ANON_WITH_CAMELLIA_256_CBC_SHA256, TLS_DH_ANON_WITH_ARIA_128_CBC_SHA256, TLS_DH_ANON_WITH_ARIA_256_CBC_SHA384, TLS_DH_ANON_WITH_ARIA_128_GCM_SHA256, TLS_DH_ANON_WITH_ARIA_256_GCM_SHA384, TLS_DH_ANON_WITH_CAMELLIA_128_GCM_SHA256, TLS_DH_ANON_WITH_CAMELLIA_256_GCM_SHA384");
				break;
			}
		return dh_server_key_exchange_;
		}
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	int val_case_index_;
	EcServerKeyExchange * ec_server_key_exchange_;
	DhServerKeyExchange * dh_server_key_exchange_;
	const_bytestring key_;
	HandshakeRecord * rec_;
};


class EcServerKeyExchange
{
public:
	EcServerKeyExchange(HandshakeRecord * rec);
	~EcServerKeyExchange();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint8 curve_type() const { return curve_type_; }
	uint16 curve() const { return curve_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint8 curve_type_;
	uint16 curve_;
	const_bytestring data_;
	HandshakeRecord * rec_;
	bool proc_;
};


class DhServerKeyExchange
{
public:
	DhServerKeyExchange(HandshakeRecord * rec);
	~DhServerKeyExchange();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint16 dh_p_length() const { return dh_p_length_; }
	bytestring const & dh_p() const { return dh_p_; }
	uint16 dh_g_length() const { return dh_g_length_; }
	bytestring const & dh_g() const { return dh_g_; }
	uint16 dh_Ys_length() const { return dh_Ys_length_; }
	bytestring const & dh_Ys() const { return dh_Ys_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint16 dh_p_length_;
	bytestring dh_p_;
	uint16 dh_g_length_;
	bytestring dh_g_;
	uint16 dh_Ys_length_;
	bytestring dh_Ys_;
	const_bytestring data_;
	HandshakeRecord * rec_;
	bool proc_;
};


class CertificateRequest
{
public:
	CertificateRequest(HandshakeRecord * rec);
	~CertificateRequest();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	const_bytestring cont_;
	HandshakeRecord * rec_;
};


class ServerHelloDone
{
public:
	ServerHelloDone(HandshakeRecord * rec);
	~ServerHelloDone();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	HandshakeRecord * rec_;
};


class ClientKeyExchange
{
public:
	ClientKeyExchange(HandshakeRecord * rec);
	~ClientKeyExchange();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	const_bytestring key_;
	HandshakeRecord * rec_;
};


class CertificateVerify
{
public:
	CertificateVerify(HandshakeRecord * rec);
	~CertificateVerify();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	const_bytestring cont_;
	HandshakeRecord * rec_;
};


class Finished
{
public:
	Finished(HandshakeRecord * rec);
	~Finished();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	HandshakeRecord * rec() const { return rec_; }
	
protected:
	const_bytestring cont_;
	HandshakeRecord * rec_;
};


class SessionTicketHandshake
{
public:
	SessionTicketHandshake(HandshakeRecord * rec);
	~SessionTicketHandshake();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint32 ticket_lifetime_hint() const { return ticket_lifetime_hint_; }
	bytestring const & data() const { return data_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint32 ticket_lifetime_hint_;
	bytestring data_;
	HandshakeRecord * rec_;
	bool proc_;
};


class SSLExtension
{
public:
	SSLExtension(HandshakeRecord * rec);
	~SSLExtension();
	int initial_buffer_length() const { return 4; }
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint16 type() const { return type_; }
	uint16 data_len() const { return data_len_; }
	int ext_case_index() const	{ return ext_case_index_; }
	vector<ApplicationLayerProtocolNegotiationExtension *> * apnl() const
		{
		switch ( ext_case_index() )
			{
			case 16:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:456:apnl", ext_case_index(), "EXT_APPLICATION_LAYER_PROTOCOL_NEGOTIATION");
				break;
			}
		return apnl_;
		}
	vector<EllipticCurves *> * elliptic_curves() const
		{
		switch ( ext_case_index() )
			{
			case 10:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:457:elliptic_curves", ext_case_index(), "EXT_ELLIPTIC_CURVES");
				break;
			}
		return elliptic_curves_;
		}
	vector<EcPointFormats *> * ec_point_formats() const
		{
		switch ( ext_case_index() )
			{
			case 11:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:458:ec_point_formats", ext_case_index(), "EXT_EC_POINT_FORMATS");
				break;
			}
		return ec_point_formats_;
		}
	vector<ServerNameExt *> * server_name() const
		{
		switch ( ext_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:460:server_name", ext_case_index(), "EXT_SERVER_NAME");
				break;
			}
		return server_name_;
		}
	bytestring const & data() const
		{
		return data_;
		}
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	const_bytestring const & sourcedata() const { return sourcedata_; }
	
protected:
	uint16 type_;
	uint16 data_len_;
	int ext_case_index_;
	vector<ApplicationLayerProtocolNegotiationExtension *> * apnl_;
	ApplicationLayerProtocolNegotiationExtension * apnl__elem_;
	vector<EllipticCurves *> * elliptic_curves_;
	EllipticCurves * elliptic_curves__elem_;
	vector<EcPointFormats *> * ec_point_formats_;
	EcPointFormats * ec_point_formats__elem_;
	vector<ServerNameExt *> * server_name_;
	ServerNameExt * server_name__elem_;
	bytestring data_;
	HandshakeRecord * rec_;
	bool proc_;
	const_bytestring sourcedata_;
};


class ServerNameHostName
{
public:
	ServerNameHostName();
	~ServerNameHostName();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint16 length() const { return length_; }
	bytestring const & host_name() const { return host_name_; }
	
protected:
	uint16 length_;
	bytestring host_name_;
};


class ServerName
{
public:
	ServerName();
	~ServerName();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 name_type() const { return name_type_; }
	int name_case_index() const	{ return name_case_index_; }
	ServerNameHostName * host_name() const
		{
		switch ( name_case_index() )
			{
			case 0:
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/bro-2.4.1/src/analyzer/protocol/ssl/tls-handshake-protocol.pac:473:host_name", name_case_index(), "((int) 0)");
				break;
			}
		return host_name_;
		}
	
protected:
	uint8 name_type_;
	int name_case_index_;
	ServerNameHostName * host_name_;
	const_bytestring data_;
};


class ServerNameExt
{
public:
	ServerNameExt(HandshakeRecord * rec);
	~ServerNameExt();
	int initial_buffer_length() const { return 2; }
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint16 length() const { return length_; }
	vector<ServerName *> * server_names() const { return server_names_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint16 length_;
	vector<ServerName *> * server_names_;
	ServerName * server_names__elem_;
	HandshakeRecord * rec_;
	bool proc_;
};


class EcPointFormats
{
public:
	EcPointFormats(HandshakeRecord * rec);
	~EcPointFormats();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context);
	
	// Member access functions
	uint8 length() const { return length_; }
	vector<uint8> * point_format_list() const { return point_format_list_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint8 length_;
	vector<uint8> * point_format_list_;
	uint8 point_format_list__elem_;
	HandshakeRecord * rec_;
	bool proc_;
};


class EllipticCurves
{
public:
	EllipticCurves(HandshakeRecord * rec);
	~EllipticCurves();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint16 length() const { return length_; }
	vector<uint16> * elliptic_curve_list() const { return elliptic_curve_list_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint16 length_;
	vector<uint16> * elliptic_curve_list_;
	uint16 elliptic_curve_list__elem_;
	HandshakeRecord * rec_;
	bool proc_;
};


class ProtocolName
{
public:
	ProtocolName();
	~ProtocolName();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 length() const { return length_; }
	bytestring const & name() const { return name_; }
	
protected:
	uint8 length_;
	bytestring name_;
};


class ApplicationLayerProtocolNegotiationExtension
{
public:
	ApplicationLayerProtocolNegotiationExtension(HandshakeRecord * rec);
	~ApplicationLayerProtocolNegotiationExtension();
	int initial_buffer_length() const { return 2; }
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextTLSHandshake * t_context, int t_byteorder);
	
	// Member access functions
	uint16 length() const { return length_; }
	vector<ProtocolName *> * protocol_name_list() const { return protocol_name_list_; }
	HandshakeRecord * rec() const { return rec_; }
	bool proc() const { return proc_; }
	
protected:
	uint16 length_;
	vector<ProtocolName *> * protocol_name_list_;
	ProtocolName * protocol_name_list__elem_;
	HandshakeRecord * rec_;
	bool proc_;
};


class Handshake_Flow : public binpac::FlowAnalyzer
{
public:
	Handshake_Flow(Handshake_Conn * connection, bool is_orig);
	~Handshake_Flow();
	
	// Member access functions
	FlowBuffer * flow_buffer() const { return flow_buffer_; }
	Handshake_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
protected:
	HandshakePDU * dataunit_;
	ContextTLSHandshake * context_;
	FlowBuffer * flow_buffer_;
	Handshake_Conn * connection_;
	bool is_orig_;
};


	class extract_certs {
	public:
		bytestring const& operator() (X509Certificate* cert) const
			{
			return cert->certificate();
			}
	};

	string orig_label(bool is_orig);
	string handshake_type_label(int type);
	
} // namespace TLSHandshake
}  // namespace binpac
#endif /* _builddir_build_BUILD_bro_2_4_1_src_analyzer_protocol_ssl_tls_handshake_pac_h */
