/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parse.y" /* yacc.c:339  */

// See the file "COPYING" in the main distribution directory for copyright.
#line 71 "parse.y" /* yacc.c:339  */

#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "input.h"
#include "Expr.h"
#include "Stmt.h"
#include "Var.h"
/* #include "analyzer/protocol/dns/DNS.h" */
#include "RE.h"
#include "Scope.h"
#include "Reporter.h"
#include "Brofiler.h"
#include "broxygen/Manager.h"

#include <set>
#include <string>

extern const char* filename;  // Absolute path of file currently being parsed.

YYLTYPE GetCurrentLocation();
extern int yyerror(const char[]);
extern int brolex();

#define YYLLOC_DEFAULT(Current, Rhs, N) \
	(Current) = (Rhs)[(N)];

/*
 * Part of the module facility: while parsing, keep track of which
 * module to put things in.
 */
string current_module = GLOBAL_MODULE_NAME;
bool is_export = false; // true if in an export {} block

/*
 * When parsing an expression for the debugger, where to put the result
 * (obviously not reentrant).
 */
extern Expr* g_curr_debug_expr;
extern bool in_debug;
extern const char* g_curr_debug_error;

#define YYLTYPE yyltype

static int in_hook = 0;
int in_init = 0;
int in_record = 0;
bool resolving_global_ID = false;
bool defining_global_ID = false;
std::vector<int> saved_in_init;

ID* func_id = 0;
EnumType *cur_enum_type = 0;
static ID* cur_decl_type_id = 0;

static void parser_new_enum (void)
	{
	/* Starting a new enum definition. */
	assert(cur_enum_type == NULL);

	if ( cur_decl_type_id )
		cur_enum_type = new EnumType(cur_decl_type_id->Name());
	else
		reporter->FatalError("incorrect syntax for enum type declaration");
	}

static void parser_redef_enum (ID *id)
	{
	/* Redef an enum. id points to the enum to be redefined.
	   Let cur_enum_type point to it. */
	assert(cur_enum_type == NULL);
	if ( ! id->Type() )
		id->Error("unknown identifier");
	else
		{
		cur_enum_type = id->Type()->AsEnumType();
		if ( ! cur_enum_type )
			id->Error("not an enum");
		}
	}

static type_decl_list* copy_type_decl_list(type_decl_list* tdl)
	{
	if ( ! tdl )
		return 0;

	type_decl_list* rval = new type_decl_list();

	loop_over_list(*tdl, i)
		{
		TypeDecl* td = (*tdl)[i];
		rval->append(new TypeDecl(*td));
		}

	return rval;
	}

static attr_list* copy_attr_list(attr_list* al)
	{
	if ( ! al )
		return 0;

	attr_list* rval = new attr_list();

	loop_over_list(*al, i)
		{
		Attr* a = (*al)[i];
		::Ref(a);
		rval->append(a);
		}

	return rval;
	}

static void extend_record(ID* id, type_decl_list* fields, attr_list* attrs)
	{
	set<BroType*> types = BroType::GetAliases(id->Name());

	if ( types.empty() )
		{
		id->Error("failed to redef record: no types found in alias map");
		return;
		}

	for ( set<BroType*>::const_iterator it = types.begin(); it != types.end(); )
		{
		RecordType* add_to = (*it)->AsRecordType();
		const char* error = 0;
		++it;

		if ( it == types.end() )
			error = add_to->AddFields(fields, attrs);
		else
			error = add_to->AddFields(copy_type_decl_list(fields),
			                          copy_attr_list(attrs));

		if ( error )
			{
			id->Error(error);
			break;
			}
		}
	}

static bool expr_is_table_type_name(const Expr* expr)
	{
	if ( expr->Tag() != EXPR_NAME )
		return false;

	BroType* type = expr->Type();

	if ( type->IsTable() )
		return true;

	if ( type->Tag() == TYPE_TYPE )
		return type->AsTypeType()->Type()->IsTable();

	return false;
	}

static bool has_attr(const attr_list* al, attr_tag tag)
	{
	if ( ! al )
		return false;

	for ( int i = 0; i < al->length(); ++i )
		if ( (*al)[i]->Tag() == tag )
			return true;

	return false;
	}

#line 243 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "broparse.h".  */
#ifndef YY_YY_BUILDDIR_BUILD_BUILD_BRO_2_4_1_BUILD_SRC_BROPARSE_H_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_BRO_2_4_1_BUILD_SRC_BROPARSE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ADD = 258,
    TOK_ADD_TO = 259,
    TOK_ADDR = 260,
    TOK_ANY = 261,
    TOK_ATENDIF = 262,
    TOK_ATELSE = 263,
    TOK_ATIF = 264,
    TOK_ATIFDEF = 265,
    TOK_ATIFNDEF = 266,
    TOK_BOOL = 267,
    TOK_BREAK = 268,
    TOK_CASE = 269,
    TOK_CONST = 270,
    TOK_CONSTANT = 271,
    TOK_COPY = 272,
    TOK_COUNT = 273,
    TOK_COUNTER = 274,
    TOK_DEFAULT = 275,
    TOK_DELETE = 276,
    TOK_DOUBLE = 277,
    TOK_ELSE = 278,
    TOK_ENUM = 279,
    TOK_EVENT = 280,
    TOK_EXPORT = 281,
    TOK_FALLTHROUGH = 282,
    TOK_FILE = 283,
    TOK_FOR = 284,
    TOK_FUNCTION = 285,
    TOK_GLOBAL = 286,
    TOK_HOOK = 287,
    TOK_ID = 288,
    TOK_IF = 289,
    TOK_INT = 290,
    TOK_INTERVAL = 291,
    TOK_LIST = 292,
    TOK_LOCAL = 293,
    TOK_MODULE = 294,
    TOK_NEXT = 295,
    TOK_OF = 296,
    TOK_OPAQUE = 297,
    TOK_PATTERN = 298,
    TOK_PATTERN_TEXT = 299,
    TOK_PORT = 300,
    TOK_PRINT = 301,
    TOK_RECORD = 302,
    TOK_REDEF = 303,
    TOK_REMOVE_FROM = 304,
    TOK_RETURN = 305,
    TOK_SCHEDULE = 306,
    TOK_SET = 307,
    TOK_STRING = 308,
    TOK_SUBNET = 309,
    TOK_SWITCH = 310,
    TOK_TABLE = 311,
    TOK_TIME = 312,
    TOK_TIMEOUT = 313,
    TOK_TIMER = 314,
    TOK_TYPE = 315,
    TOK_UNION = 316,
    TOK_VECTOR = 317,
    TOK_WHEN = 318,
    TOK_WHILE = 319,
    TOK_ATTR_ADD_FUNC = 320,
    TOK_ATTR_ENCRYPT = 321,
    TOK_ATTR_DEFAULT = 322,
    TOK_ATTR_OPTIONAL = 323,
    TOK_ATTR_REDEF = 324,
    TOK_ATTR_ROTATE_INTERVAL = 325,
    TOK_ATTR_ROTATE_SIZE = 326,
    TOK_ATTR_DEL_FUNC = 327,
    TOK_ATTR_EXPIRE_FUNC = 328,
    TOK_ATTR_EXPIRE_CREATE = 329,
    TOK_ATTR_EXPIRE_READ = 330,
    TOK_ATTR_EXPIRE_WRITE = 331,
    TOK_ATTR_PERSISTENT = 332,
    TOK_ATTR_SYNCHRONIZED = 333,
    TOK_ATTR_RAW_OUTPUT = 334,
    TOK_ATTR_MERGEABLE = 335,
    TOK_ATTR_PRIORITY = 336,
    TOK_ATTR_LOG = 337,
    TOK_ATTR_ERROR_HANDLER = 338,
    TOK_ATTR_TYPE_COLUMN = 339,
    TOK_ATTR_DEPRECATED = 340,
    TOK_DEBUG = 341,
    TOK_NO_TEST = 342,
    TOK_OR = 343,
    TOK_AND = 344,
    TOK_LE = 345,
    TOK_GE = 346,
    TOK_EQ = 347,
    TOK_NE = 348,
    TOK_IN = 349,
    TOK_NOT_IN = 350,
    TOK_INCR = 351,
    TOK_DECR = 352,
    TOK_HAS_FIELD = 353,
    TOK_HAS_ATTR = 354
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 245 "parse.y" /* yacc.c:355  */

	bool b;
	char* str;
	ID* id;
	id_list* id_l;
	init_class ic;
	Val* val;
	RE_Matcher* re;
	Expr* expr;
	EventExpr* event_expr;
	Stmt* stmt;
	ListExpr* list;
	BroType* type;
	RecordType* record;
	FuncType* func_type;
	TypeList* type_l;
	TypeDecl* type_decl;
	type_decl_list* type_decl_l;
	Case* c_case;
	case_list* case_l;
	Attr* attr;
	attr_list* attr_l;
	attr_tag attrtag;

#line 408 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;
int yyparse (void);

#endif /* !YY_YY_BUILDDIR_BUILD_BUILD_BRO_2_4_1_BUILD_SRC_BROPARSE_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 437 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1916

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  121
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  75
/* YYNRULES -- Number of rules.  */
#define YYNRULES  243
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  539

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   354

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   110,     2,     2,   111,   107,     2,     2,
     114,   115,   105,   103,    88,   104,     2,   106,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    92,   120,
      95,    90,    96,    91,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   112,     2,   113,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   118,    89,   119,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    93,    94,    97,    98,    99,   100,   101,
     102,   108,   109,   116,   117
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   273,   273,   288,   288,   295,   296,   300,   303,   307,
     313,   319,   325,   331,   337,   343,   349,   355,   361,   367,
     373,   379,   385,   391,   397,   403,   409,   415,   421,   427,
     433,   439,   445,   451,   457,   463,   473,   479,   486,   485,
     500,   506,   512,   537,   544,   550,   550,   550,   557,   563,
     570,   576,   569,   618,   618,   627,   633,   635,   641,   690,
     696,   703,   711,   717,   725,   727,   731,   737,   745,   745,
     745,   750,   756,   764,   766,   775,   787,   796,   805,   810,
     815,   820,   825,   830,   835,   840,   845,   850,   855,   860,
     865,   870,   875,   881,   888,   890,   887,   897,   904,   904,
     911,   919,   927,   933,   939,   945,   951,   957,   963,   969,
     989,   991,   999,  1004,  1010,  1021,  1023,  1026,  1030,  1032,
    1034,  1039,  1047,  1053,  1053,  1056,  1062,  1068,  1075,  1074,
    1082,  1084,  1086,  1081,  1098,  1097,  1106,  1109,  1113,  1115,
    1117,  1119,  1121,  1126,  1133,  1139,  1147,  1157,  1166,  1156,
    1178,  1183,  1192,  1194,  1199,  1202,  1206,  1207,  1208,  1209,
    1213,  1213,  1213,  1216,  1220,  1222,  1224,  1228,  1230,  1234,
    1236,  1244,  1246,  1248,  1250,  1252,  1254,  1256,  1258,  1260,
    1262,  1264,  1266,  1268,  1270,  1272,  1274,  1276,  1278,  1280,
    1282,  1284,  1286,  1291,  1299,  1307,  1315,  1321,  1327,  1333,
    1338,  1343,  1351,  1359,  1367,  1375,  1383,  1391,  1399,  1407,
    1415,  1421,  1430,  1436,  1444,  1452,  1458,  1463,  1470,  1474,
    1486,  1489,  1493,  1496,  1501,  1527,  1532,  1534,  1542,  1563,
    1563,  1568,  1568,  1568,  1573,  1573,  1578,  1614,  1627,  1630,
    1633,  1636,  1639,  1642
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ADD", "TOK_ADD_TO", "TOK_ADDR",
  "TOK_ANY", "TOK_ATENDIF", "TOK_ATELSE", "TOK_ATIF", "TOK_ATIFDEF",
  "TOK_ATIFNDEF", "TOK_BOOL", "TOK_BREAK", "TOK_CASE", "TOK_CONST",
  "TOK_CONSTANT", "TOK_COPY", "TOK_COUNT", "TOK_COUNTER", "TOK_DEFAULT",
  "TOK_DELETE", "TOK_DOUBLE", "TOK_ELSE", "TOK_ENUM", "TOK_EVENT",
  "TOK_EXPORT", "TOK_FALLTHROUGH", "TOK_FILE", "TOK_FOR", "TOK_FUNCTION",
  "TOK_GLOBAL", "TOK_HOOK", "TOK_ID", "TOK_IF", "TOK_INT", "TOK_INTERVAL",
  "TOK_LIST", "TOK_LOCAL", "TOK_MODULE", "TOK_NEXT", "TOK_OF",
  "TOK_OPAQUE", "TOK_PATTERN", "TOK_PATTERN_TEXT", "TOK_PORT", "TOK_PRINT",
  "TOK_RECORD", "TOK_REDEF", "TOK_REMOVE_FROM", "TOK_RETURN",
  "TOK_SCHEDULE", "TOK_SET", "TOK_STRING", "TOK_SUBNET", "TOK_SWITCH",
  "TOK_TABLE", "TOK_TIME", "TOK_TIMEOUT", "TOK_TIMER", "TOK_TYPE",
  "TOK_UNION", "TOK_VECTOR", "TOK_WHEN", "TOK_WHILE", "TOK_ATTR_ADD_FUNC",
  "TOK_ATTR_ENCRYPT", "TOK_ATTR_DEFAULT", "TOK_ATTR_OPTIONAL",
  "TOK_ATTR_REDEF", "TOK_ATTR_ROTATE_INTERVAL", "TOK_ATTR_ROTATE_SIZE",
  "TOK_ATTR_DEL_FUNC", "TOK_ATTR_EXPIRE_FUNC", "TOK_ATTR_EXPIRE_CREATE",
  "TOK_ATTR_EXPIRE_READ", "TOK_ATTR_EXPIRE_WRITE", "TOK_ATTR_PERSISTENT",
  "TOK_ATTR_SYNCHRONIZED", "TOK_ATTR_RAW_OUTPUT", "TOK_ATTR_MERGEABLE",
  "TOK_ATTR_PRIORITY", "TOK_ATTR_LOG", "TOK_ATTR_ERROR_HANDLER",
  "TOK_ATTR_TYPE_COLUMN", "TOK_ATTR_DEPRECATED", "TOK_DEBUG",
  "TOK_NO_TEST", "','", "'|'", "'='", "'?'", "':'", "TOK_OR", "TOK_AND",
  "'<'", "'>'", "TOK_LE", "TOK_GE", "TOK_EQ", "TOK_NE", "TOK_IN",
  "TOK_NOT_IN", "'+'", "'-'", "'*'", "'/'", "'%'", "TOK_INCR", "TOK_DECR",
  "'!'", "'$'", "'['", "']'", "'('", "')'", "TOK_HAS_FIELD",
  "TOK_HAS_ATTR", "'{'", "'}'", "';'", "$accept", "bro", "$@1",
  "decl_list", "opt_expr", "expr", "$@2", "$@3", "$@4", "$@5", "$@6",
  "$@7", "expr_list", "opt_expr_list", "pattern", "single_pattern", "$@8",
  "$@9", "enum_body", "enum_body_list", "enum_body_elem", "type", "$@10",
  "$@11", "$@12", "type_list", "type_decl_list", "type_decl",
  "formal_args", "formal_args_decl_list", "formal_args_decl", "decl",
  "$@13", "$@14", "$@15", "$@16", "$@17", "$@18", "conditional",
  "func_hdr", "func_body", "$@19", "$@20", "anonymous_function",
  "begin_func", "func_params", "opt_type", "init_class", "opt_init",
  "$@21", "$@22", "init", "opt_attr", "attr_list", "attr", "stmt",
  "stmt_list", "event", "case_list", "case", "for_head", "local_id_list",
  "local_id", "global_id", "$@23", "def_global_id", "$@24", "$@25",
  "event_id", "$@26", "global_or_event_id", "resolve_id", "opt_no_test",
  "opt_no_test_block", "opt_deprecated", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    44,   124,
      61,    63,    58,   343,   344,    60,    62,   345,   346,   347,
     348,   349,   350,    43,    45,    42,    47,    37,   351,   352,
      33,    36,    91,    93,    40,    41,   353,   354,   123,   125,
      59
};
# endif

#define YYPACT_NINF -453

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-453)))

#define YYTABLE_NINF -164

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-164)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -56,  -453,    47,   234,  1744,  -453,  -453,  -453,   -58,   -51,
     -39,  -453,  -453,   -26,  -453,  -453,  -453,    74,    54,  -453,
    -453,  -453,  1742,   727,  -453,     7,    12,  -453,  -453,    82,
      17,  1744,    18,    43,    45,  1744,  1744,  1744,  -453,  1744,
    1744,  1744,   130,  1659,  1744,  1428,    76,  -453,  -453,  1744,
     133,   136,    79,  -453,    12,   143,  -453,    12,    79,    12,
      70,  -453,  -453,  -453,    79,   143,   100,   103,   105,   106,
    -453,  -453,   110,   111,   124,   126,   129,   132,   134,  -453,
    -453,  -453,  -453,   137,  -453,  -453,   138,  -453,  -453,   108,
    1742,  -453,  1744,   112,    82,  1744,   190,   113,   120,   121,
      82,   116,  1744,  1520,  1744,   125,   139,   151,  -453,   478,
    -453,  -453,   727,  1744,   207,  1742,  -453,  1744,  -453,   157,
    1744,   824,  1744,  -453,  1744,   971,    11,    11,   204,    11,
      11,    11,   -48,  -453,  1428,   -67,  1000,  1744,  1744,  1744,
    1744,  1744,  1744,  1744,  1744,  1744,  1744,  1744,  1744,  1744,
    1744,  1744,  1744,  1744,  1744,  1744,   217,  1744,  -453,   218,
     148,  1030,   140,   141,  1854,     6,  -453,  -453,  -453,  -453,
    -453,  -453,     6,  -453,  -453,   257,    12,  -453,     6,  -453,
    -453,  1744,  1744,  1744,  1744,  1744,  1744,  1744,  1744,  1744,
    1744,  1744,  1744,  -453,  -453,   592,   175,    79,   706,   149,
     147,   175,    -8,  1744,    20,   175,   -62,   155,   175,   765,
     853,  1744,  1744,  -453,  -453,   175,  -453,  1059,   178,   156,
     -59,  -453,  -453,  1428,  1744,   -71,   190,   184,   161,  1744,
     162,  -453,  -453,  1744,   188,  1744,  -453,  -453,  1428,  1428,
    1428,  1118,   794,   940,  1087,  1087,  1087,  1087,  1087,  1087,
      99,    99,   179,   179,    11,    11,    11,  -453,   182,  1147,
     -29,  1744,  -453,  -453,  -453,  -453,  -453,  -453,  -453,  -453,
    -453,  -453,  -453,   165,   166,   238,    12,   186,  -453,  -453,
    -453,   248,   251,  -453,  -453,   180,   189,  -453,  -453,   191,
    -453,  -453,   187,   255,  -453,  -453,  -453,  -453,  -453,   383,
    -453,    42,   383,   192,  -453,   300,   383,  1854,  1428,  1428,
    1428,  1428,  1428,  1428,  1428,  1428,  1428,  1428,  1428,  1428,
    -453,   175,  -453,  -453,     6,   175,  1744,   175,  -453,   205,
      82,  1177,     6,  -453,   175,  1744,  -453,   175,  -453,  1251,
    1281,   380,  -453,  -453,  1854,   216,   207,   207,  1428,  -453,
     193,  1742,   194,  -453,   208,  1428,  -453,  1428,  1744,  1744,
    -453,  -453,  -453,   207,  1854,  -453,   207,  1854,   278,  -453,
    1854,  1854,  1854,  1854,  1742,  1631,  -453,  1742,  -453,   195,
    1742,  1742,   727,  -453,   383,  -453,   200,  -453,  1744,   -24,
    -453,   727,   383,  -453,  1310,  -453,     0,   727,   727,  -453,
    1742,  1854,  -453,  -453,  -453,  -453,  -453,  -453,  1742,  1222,
     203,  1428,   202,   285,   209,  -453,   210,  -453,  -453,  -453,
    -453,   -19,   -18,   -65,  -453,   199,  1744,  1428,  -453,   206,
     285,  -453,   213,   215,   211,  1742,  -453,  1369,    82,   226,
     305,  1742,   727,  1744,   237,  -453,  -453,   280,  -453,  -453,
    -453,  1742,  -453,  -453,  -453,   -25,   220,   252,  -453,  -453,
    -453,   303,  1854,  -453,   301,  -453,  -453,   258,   228,  -453,
    -453,   229,  -453,  -453,  -453,  -453,   230,  -453,  -453,  1744,
     727,   231,   291,     5,  -453,  1744,  -453,  -453,    -1,  -453,
    -453,   285,   260,   239,  -453,  -453,  1854,  1548,  -453,   233,
     303,   175,  1398,  -453,   175,  1744,  -453,   727,   883,   271,
     343,  -453,  1854,  -453,  -453,  -453,  -453,   241,  -453,  -453,
    -453,   912,   727,   151,  -453,  -453,  1742,  1742,   151,  -453,
     242,   243,  -453,   499,  -453,  -453,   613,  -453,  -453
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       6,     3,     0,   218,     0,     1,   141,   142,     0,     0,
       0,   231,   234,     0,   231,   231,   231,     0,   229,   229,
       5,   137,   168,     2,    59,     0,     0,    53,    58,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    68,     0,
       0,     0,     0,     0,     0,     4,    60,    67,    56,     0,
       0,     0,   155,   229,     0,     0,   123,     0,   155,     0,
       0,   229,   234,   229,   155,     0,     0,     0,   184,     0,
     172,   173,     0,     0,     0,     0,     0,     0,     0,   182,
     183,   186,   187,     0,   190,   191,     0,   192,   136,     0,
     167,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   241,   215,     0,
     216,   217,     0,     0,   117,   168,   151,     0,   228,     0,
       0,     0,    65,    45,    65,     0,    15,    14,     0,    11,
      12,    13,     0,    43,    63,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     8,    50,     0,
       0,     0,     0,     0,     0,   156,   232,   144,   236,   235,
       6,   143,   156,   145,   122,     0,     0,   130,   156,   230,
     134,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   147,   169,     0,   239,   155,     0,     0,
       0,   239,     0,     0,   155,   239,     0,     0,   239,     0,
       0,     0,     0,   240,   218,   239,   199,     0,     0,     0,
     115,   120,   150,    54,     0,     0,     0,    64,     0,    65,
       0,    61,    69,     0,     0,     0,    42,     9,    17,    19,
      32,     0,    24,    23,    27,    29,    28,    30,    25,    26,
      40,    41,    16,    18,    20,    21,    22,    36,     0,    63,
       0,    65,    55,    66,   138,   139,   140,    89,    91,    78,
      80,    81,    82,     0,     0,   107,     0,     0,   237,    79,
      84,   100,     0,    86,    88,     0,     0,    85,    90,     0,
      83,    87,     0,     0,   154,   109,   158,   159,   157,   160,
     233,     0,   160,     0,   146,     0,   160,     0,   176,   185,
     171,   174,   175,   177,   178,   179,   180,   181,   188,   189,
     218,   239,   238,   202,   156,   239,    65,   239,   203,     0,
       0,     0,   156,   201,   239,     0,   204,   239,   221,     0,
       0,     0,   214,    10,     0,   153,     0,   116,    33,    44,
       0,   168,     0,    49,     0,    37,    38,    62,     0,     8,
      34,    51,    98,   117,     0,   103,   117,     0,     0,    94,
       0,     0,     0,     0,   168,     0,   124,   168,   128,     0,
     168,   168,   148,   206,   160,   207,     0,   195,     0,     0,
     227,     0,   160,   194,     0,   205,     0,     0,     0,   193,
     168,     0,   119,   118,    57,    48,    46,    70,   168,    31,
       0,     7,     0,     0,     0,   106,     0,   101,   108,   113,
     111,     0,     0,     0,   102,     0,    65,   166,   161,     0,
       0,   131,     0,     0,     0,   168,   219,     0,     0,     0,
     196,   168,     0,     0,     0,   198,   220,   210,   200,   121,
     152,   168,    39,    35,    52,   243,     0,    71,    73,   104,
     105,    95,     0,    93,     0,    97,   126,    64,     0,   162,
     125,     0,   113,   127,   135,   149,     0,   224,   226,     0,
       0,     0,   212,     0,   218,     0,    47,   242,     0,    77,
      99,    72,     0,     0,   112,   110,     0,     0,   164,     0,
     132,   239,     0,   197,   239,     0,   218,   223,     0,   243,
       0,    74,     0,    96,    92,   165,   129,     0,   209,   225,
     208,     0,   222,   241,    75,    76,   168,   168,   241,   218,
       0,     0,   218,     0,   114,   133,     0,   211,   213
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -453,  -453,  -453,   196,     2,    -4,  -453,  -453,  -453,  -453,
    -453,  -453,   -40,  -105,  -453,   212,  -453,  -453,   -66,  -453,
    -126,  -155,  -453,  -453,  -453,  -289,  -104,  -453,  -258,  -453,
    -218,  -453,  -453,  -453,  -453,  -453,  -453,  -453,     1,  -453,
    -109,  -453,  -453,  -453,  -453,   -46,   -42,  -160,  -278,  -453,
    -453,  -453,  -183,  -453,   277,  -110,  -209,   150,  -453,  -453,
    -453,  -453,   -93,    24,  -453,   159,  -453,  -453,   307,  -453,
     308,  -453,  -167,  -452,  -135
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,   258,   109,   408,   229,   451,   261,
     412,   117,   227,   228,    46,    47,   128,   354,   456,   457,
     458,   420,   419,   493,   413,   421,   461,   494,   219,   220,
     221,    20,   170,   430,   305,   472,   517,   307,   110,    22,
      88,   320,   434,    48,   115,   116,   165,   299,   374,   375,
     469,   428,    89,    90,    91,   111,    23,   200,   396,   446,
     112,   389,   119,    64,    65,    52,    53,   300,    54,    55,
     169,   295,   323,   214,   489
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      45,   197,   216,   135,    21,   341,   222,   204,   167,   294,
     296,   171,   302,   173,   443,   509,   172,   235,   306,   230,
     444,   235,   178,   462,   377,   329,   235,   121,   380,   346,
       1,   125,   126,   127,   328,   129,   130,   131,   333,   134,
     136,   336,   233,    66,   349,   161,   236,     5,   342,     6,
       7,     8,     9,    10,   465,   297,    49,    11,   334,   235,
     487,   347,   206,    50,   438,   488,   114,    12,    13,   462,
     462,   529,    14,    15,    16,    51,   532,   166,    61,    62,
     225,    17,   422,   423,   360,   175,   234,   177,   195,   439,
      18,   198,    56,   235,   463,   464,   298,   506,   134,   209,
     210,    63,    19,   510,   330,   414,   435,    60,   416,   217,
     224,   382,   164,   223,   441,   118,   134,   260,   134,   445,
     134,   113,   156,   157,   352,   158,   114,   159,   402,   403,
     304,   120,   122,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   381,   259,   383,   324,   361,   123,   385,   124,
     387,   376,   332,   132,   384,   160,   162,   393,   405,   163,
     395,   164,   392,    57,    58,    59,   168,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   400,
     174,   425,   180,   181,   429,   182,   183,   432,   433,   331,
     184,   185,   151,   152,   153,   154,   155,   339,   340,   415,
     156,   157,   417,   158,   186,   159,   187,   449,   424,   188,
     348,   386,   189,   199,   190,   134,   193,   191,   192,   355,
     365,   357,   196,   201,   202,   203,   205,   390,   213,   211,
     218,     6,     7,     8,     9,    10,   450,   224,   232,    11,
     257,   262,   476,   212,    38,   265,   266,   134,   481,    12,
      13,   303,   322,   326,    14,    15,    16,   327,   486,   335,
     344,   345,   235,    17,   359,   507,   351,   353,   356,   364,
     363,   440,    18,   362,   153,   154,   155,   447,   448,   367,
     156,   157,   368,   158,    19,   159,   373,   522,   369,   452,
     366,   370,    21,   371,   379,   372,   388,   495,   401,   406,
     378,   418,   404,   431,   407,   436,   453,   454,   455,   466,
     533,   468,   134,   536,   459,   460,   470,   479,   480,   484,
     475,   394,   482,   473,   518,   474,   492,   520,   485,   490,
     491,   514,   496,   530,   531,   478,   497,   498,   499,   505,
     501,   504,   512,   516,   409,   411,   487,   526,   513,   525,
     527,   410,   534,   535,   471,   511,   301,   194,   500,   176,
     503,   427,   263,   179,   524,     0,   350,     0,     0,     0,
       0,     0,     0,    92,   437,     0,   467,     6,     7,     8,
       9,    10,     0,    93,     0,    94,    24,    25,     0,     0,
       0,    95,     0,   483,     0,    96,     0,    97,     0,    98,
      26,     0,    27,    28,    99,     0,     0,     0,   100,     0,
     101,     0,   134,     0,     0,     0,   102,    30,     0,     0,
     103,    31,    32,     0,     0,   104,    33,     0,     0,   134,
       0,     0,    34,   105,   106,     0,     0,     0,  -163,  -163,
    -163,  -163,  -163,  -163,  -163,  -163,  -163,  -163,  -163,  -163,
    -163,  -163,  -163,  -163,  -163,  -163,  -163,  -163,  -163,    35,
       0,     0,     0,     0,     0,   502,     0,     0,     0,     0,
       0,   508,   137,    36,    37,     0,    38,     0,    39,    40,
      41,    42,    43,   357,    44,     0,     0,     0,   107,   399,
     108,   521,    92,  -163,     0,     0,     6,     7,     8,     9,
      10,     0,    93,     0,    94,    24,    25,     0,     0,     0,
      95,     0,     0,     0,    96,     0,    97,   138,    98,    26,
       0,    27,    28,    99,     0,     0,     0,   100,     0,   101,
       0,     0,     0,     0,     0,   102,    30,     0,     0,   103,
      31,    32,     0,     0,   104,    33,     0,     0,     0,     0,
       0,    34,   105,   106,     0,     0,     0,     0,   139,   140,
       0,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,     0,     0,    35,   156,
     157,     0,   158,     0,   159,     0,   137,     0,   215,     0,
       0,     0,    36,    37,     0,    38,     0,    39,    40,    41,
      42,    43,     0,    44,     0,     0,    92,   107,   537,   108,
       6,     7,     8,     9,    10,     0,    93,     0,    94,    24,
      25,     0,     0,     0,    95,     0,     0,     0,    96,     0,
      97,   138,    98,    26,     0,    27,    28,    99,     0,     0,
       0,   100,     0,   101,     0,     0,     0,     0,     0,   102,
      30,     0,     0,   103,    31,    32,     0,     0,   104,    33,
       0,     0,     0,     0,     0,    34,   105,   106,     0,     0,
       0,     0,   139,   140,     0,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
       0,     0,    35,   156,   157,     0,   158,     0,   159,     0,
     137,     0,   321,     0,     0,     0,    36,    37,     0,    38,
       0,    39,    40,    41,    42,    43,     0,    44,     0,     0,
      92,   107,   538,   108,     6,     7,     8,     9,    10,     0,
      93,     0,    94,    24,    25,     0,     0,     0,    95,     0,
       0,     0,    96,     0,    97,   138,    98,    26,     0,    27,
      28,    99,     0,     0,     0,   100,     0,   101,     0,   137,
       0,     0,     0,   102,    30,     0,     0,   103,    31,    32,
       0,     0,   104,    33,     0,     0,     0,     0,     0,    34,
     105,   106,     0,     0,     0,     0,   139,   140,     0,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   138,     0,    35,   156,   157,     0,
     158,     0,   159,     0,     0,     0,   325,     0,   137,     0,
      36,    37,     0,    38,     0,    39,    40,    41,    42,    43,
       0,    44,     0,     0,     0,   107,     0,   108,     0,     0,
       0,     0,     0,     0,     0,   139,   140,   137,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   138,     0,     0,   156,   157,     0,   158,
       0,   159,     0,     0,     0,   337,     0,   137,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   138,     0,     0,   156,   157,     0,   158,     0,
     159,     0,     0,     0,   139,   140,   137,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   138,     0,     0,   156,   157,     0,   158,     0,
     159,     0,   226,   139,   140,     0,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   138,     0,     0,   156,   157,     0,   158,     0,   159,
       0,   338,     0,   139,   140,   137,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,     0,     0,     0,   156,   157,     0,   158,     0,   159,
       0,   523,   139,   140,   137,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     138,     0,     0,   156,   157,     0,   158,     0,   159,     0,
     528,     0,     0,     0,   137,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,     0,   138,
       0,   156,   157,     0,   158,     0,   159,     0,     0,     0,
     231,   139,   140,   137,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   138,
       0,     0,   156,   157,     0,   158,     0,   159,     0,     0,
     139,   140,     0,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   138,     0,
       0,   156,   157,     0,   158,   237,   159,     0,     0,     0,
     139,   140,   137,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,     0,     0,
       0,   156,   157,     0,   158,   264,   159,     0,     0,   139,
     140,   137,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   138,     0,     0,
     156,   157,     0,   158,   343,   159,     0,     0,     0,     0,
       0,   137,  -164,  -164,  -164,  -164,  -164,  -164,   149,   150,
     151,   152,   153,   154,   155,     0,   138,     0,   156,   157,
       0,   158,     0,   159,     0,     0,     0,     0,   139,   140,
     358,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   138,     0,     0,   156,
     157,     0,   158,     0,   159,     0,     0,   139,   140,    -7,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   137,     0,     0,   156,   157,
       0,   158,     0,   159,     0,     0,     0,   139,   140,     0,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   137,     0,     0,   156,   157,
       0,   158,   391,   159,     0,     0,     0,     0,     0,     0,
     138,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   140,   137,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     138,     0,     0,   156,   157,     0,   158,     0,   159,     0,
       0,   139,   140,     0,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   138,
       0,     0,   156,   157,     0,   158,   397,   159,     0,     0,
       0,   139,   140,   137,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,     0,
       0,     0,   156,   157,     0,   158,   398,   159,     0,     0,
     139,   140,   137,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   138,     0,
       0,   156,   157,     0,   158,   442,   159,     0,     0,     0,
       0,     0,   137,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   138,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   139,
     140,     0,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   138,     0,     0,
     156,   157,     0,   158,   477,   159,     0,     0,   139,   140,
       0,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,     0,     0,     0,   156,
     157,     0,   158,   519,   159,     0,     0,     0,   139,   140,
       0,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    24,    25,     0,   156,
     157,     0,   158,     0,   159,     0,     0,     0,     0,     0,
      26,     0,    27,    28,     0,     0,     0,     0,    29,     0,
       0,     0,     0,     0,    24,    25,     0,    30,     0,     0,
       0,    31,    32,     0,     0,     0,    33,     0,    26,     0,
      27,    28,    34,   207,     0,     0,    29,     0,     0,     0,
       0,     0,     0,     0,     0,    30,     0,     0,     0,    31,
      32,     0,     0,     0,    33,     0,     0,     0,     0,    35,
      34,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    36,    37,     0,    38,     0,    39,    40,
      41,    42,    43,     0,    44,     0,     0,    35,     0,     0,
     208,     0,     0,     0,     0,     0,     0,    24,    25,     0,
       0,    36,    37,     0,    38,     0,    39,    40,    41,    42,
      43,    26,    44,    27,    28,     0,     0,   515,     0,    29,
       0,     0,     0,     0,     0,    24,    25,     0,    30,     0,
       0,     0,    31,    32,     0,     0,     0,    33,     0,    26,
       0,    27,    28,    34,     0,     0,     0,    29,     0,     0,
       0,     0,     0,     0,     0,     0,    30,     0,     0,     0,
      31,    32,     0,     0,     0,    33,     0,     0,     0,     0,
      35,    34,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    36,    37,     0,    38,     0,    39,
      40,    41,    42,    43,     0,    44,     0,     0,    35,   426,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      24,    25,    36,    37,     0,    38,     0,    39,    40,    41,
      42,    43,   133,    44,    26,     0,    27,    28,     0,     0,
       0,     0,    29,     0,     0,     0,     0,     0,     0,     0,
       0,    30,     0,     0,     0,    31,    32,     0,     0,     0,
      33,     0,     0,     0,     0,     0,    34,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     0,     0,
       0,     0,     0,    35,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,    37,     0,
      38,     0,    39,    40,    41,    42,    43,     0,    44,   267,
     268,     0,     0,     0,     0,     0,   269,     0,     0,     0,
       0,     0,   270,   271,     0,     0,   272,     0,   273,   274,
       0,     0,   275,     0,   276,     0,   277,   278,     0,   279,
     280,   281,     0,     0,     0,     0,   282,   283,     0,   284,
       0,   285,     0,     0,     0,     0,   286,   287,   288,     0,
     289,   290,     0,   291,     0,   292,   293
};

static const yytype_int16 yycheck[] =
{
       4,    94,   112,    43,     3,   214,   115,   100,    54,   164,
       4,    57,   172,    59,    14,    16,    58,    88,   178,   124,
      20,    88,    64,    88,   302,    33,    88,    31,   306,    88,
      86,    35,    36,    37,   201,    39,    40,    41,   205,    43,
      44,   208,    90,    19,   115,    49,   113,     0,   215,     7,
       8,     9,    10,    11,   119,    49,   114,    15,   120,    88,
      85,   120,   102,   114,    88,    90,   114,    25,    26,    88,
      88,   523,    30,    31,    32,   114,   528,    53,    24,    25,
     120,    39,   371,   372,   113,    61,   132,    63,    92,   113,
      48,    95,   118,    88,   113,   113,    90,    92,   102,   103,
     104,    47,    60,   104,   112,   363,   384,    33,   366,   113,
      90,   320,    92,   117,   392,    33,   120,   157,   122,   119,
     124,   114,   111,   112,   229,   114,   114,   116,   346,   347,
     176,   114,   114,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   307,   157,   321,   197,   261,   114,   325,   114,
     327,   119,   204,    33,   324,    89,    33,   334,   351,    33,
     337,    92,   332,    14,    15,    16,    33,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   344,
     120,   374,    92,    90,   377,    90,    90,   380,   381,   203,
      90,    90,   103,   104,   105,   106,   107,   211,   212,   364,
     111,   112,   367,   114,    90,   116,    90,   400,   373,    90,
     224,   326,    90,    33,    90,   229,   118,    90,    90,   233,
     276,   235,   120,   120,   114,   114,   120,   330,    87,   114,
      33,     7,     8,     9,    10,    11,   401,    90,    44,    15,
      33,    33,   435,   114,   106,   115,   115,   261,   441,    25,
      26,     4,    87,   114,    30,    31,    32,   120,   451,   114,
      92,   115,    88,    39,    92,   484,   115,   115,    90,    41,
     114,   391,    48,   118,   105,   106,   107,   397,   398,    41,
     111,   112,    41,   114,    60,   116,    41,   506,   118,   408,
     114,   112,   301,   112,     4,   118,   101,   462,    92,   115,
     118,    33,   119,   118,   106,   115,   113,   115,    33,   120,
     529,   426,   326,   532,   115,   115,   120,   101,    23,    92,
     119,   335,   442,   120,   501,   120,    33,   504,    58,   119,
      88,   496,    41,   526,   527,   438,    88,   119,   119,    58,
     120,   120,    92,   120,   358,   359,    85,   512,   119,    16,
     119,   359,   120,   120,   430,   491,   170,    90,   472,    62,
     480,   375,   160,    65,   509,    -1,   226,    -1,    -1,    -1,
      -1,    -1,    -1,     3,   388,    -1,   426,     7,     8,     9,
      10,    11,    -1,    13,    -1,    15,    16,    17,    -1,    -1,
      -1,    21,    -1,   443,    -1,    25,    -1,    27,    -1,    29,
      30,    -1,    32,    33,    34,    -1,    -1,    -1,    38,    -1,
      40,    -1,   426,    -1,    -1,    -1,    46,    47,    -1,    -1,
      50,    51,    52,    -1,    -1,    55,    56,    -1,    -1,   443,
      -1,    -1,    62,    63,    64,    -1,    -1,    -1,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    89,
      -1,    -1,    -1,    -1,    -1,   479,    -1,    -1,    -1,    -1,
      -1,   485,     4,   103,   104,    -1,   106,    -1,   108,   109,
     110,   111,   112,   497,   114,    -1,    -1,    -1,   118,   119,
     120,   505,     3,   120,    -1,    -1,     7,     8,     9,    10,
      11,    -1,    13,    -1,    15,    16,    17,    -1,    -1,    -1,
      21,    -1,    -1,    -1,    25,    -1,    27,    49,    29,    30,
      -1,    32,    33,    34,    -1,    -1,    -1,    38,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    46,    47,    -1,    -1,    50,
      51,    52,    -1,    -1,    55,    56,    -1,    -1,    -1,    -1,
      -1,    62,    63,    64,    -1,    -1,    -1,    -1,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    -1,    -1,    89,   111,
     112,    -1,   114,    -1,   116,    -1,     4,    -1,   120,    -1,
      -1,    -1,   103,   104,    -1,   106,    -1,   108,   109,   110,
     111,   112,    -1,   114,    -1,    -1,     3,   118,   119,   120,
       7,     8,     9,    10,    11,    -1,    13,    -1,    15,    16,
      17,    -1,    -1,    -1,    21,    -1,    -1,    -1,    25,    -1,
      27,    49,    29,    30,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    40,    -1,    -1,    -1,    -1,    -1,    46,
      47,    -1,    -1,    50,    51,    52,    -1,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    62,    63,    64,    -1,    -1,
      -1,    -1,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,    -1,    89,   111,   112,    -1,   114,    -1,   116,    -1,
       4,    -1,   120,    -1,    -1,    -1,   103,   104,    -1,   106,
      -1,   108,   109,   110,   111,   112,    -1,   114,    -1,    -1,
       3,   118,   119,   120,     7,     8,     9,    10,    11,    -1,
      13,    -1,    15,    16,    17,    -1,    -1,    -1,    21,    -1,
      -1,    -1,    25,    -1,    27,    49,    29,    30,    -1,    32,
      33,    34,    -1,    -1,    -1,    38,    -1,    40,    -1,     4,
      -1,    -1,    -1,    46,    47,    -1,    -1,    50,    51,    52,
      -1,    -1,    55,    56,    -1,    -1,    -1,    -1,    -1,    62,
      63,    64,    -1,    -1,    -1,    -1,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    49,    -1,    89,   111,   112,    -1,
     114,    -1,   116,    -1,    -1,    -1,   120,    -1,     4,    -1,
     103,   104,    -1,   106,    -1,   108,   109,   110,   111,   112,
      -1,   114,    -1,    -1,    -1,   118,    -1,   120,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    91,     4,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,    49,    -1,    -1,   111,   112,    -1,   114,
      -1,   116,    -1,    -1,    -1,   120,    -1,     4,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    49,    -1,    -1,   111,   112,    -1,   114,    -1,
     116,    -1,    -1,    -1,    90,    91,     4,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    49,    -1,    -1,   111,   112,    -1,   114,    -1,
     116,    -1,   118,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    49,    -1,    -1,   111,   112,    -1,   114,    -1,   116,
      -1,   118,    -1,    90,    91,     4,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    -1,    -1,    -1,   111,   112,    -1,   114,    -1,   116,
      -1,   118,    90,    91,     4,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      49,    -1,    -1,   111,   112,    -1,   114,    -1,   116,    -1,
     118,    -1,    -1,    -1,     4,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    -1,    49,
      -1,   111,   112,    -1,   114,    -1,   116,    -1,    -1,    -1,
      89,    90,    91,     4,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    49,
      -1,    -1,   111,   112,    -1,   114,    -1,   116,    -1,    -1,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    49,    -1,
      -1,   111,   112,    -1,   114,   115,   116,    -1,    -1,    -1,
      90,    91,     4,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    -1,    -1,
      -1,   111,   112,    -1,   114,   115,   116,    -1,    -1,    90,
      91,     4,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    49,    -1,    -1,
     111,   112,    -1,   114,   115,   116,    -1,    -1,    -1,    -1,
      -1,     4,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    -1,    49,    -1,   111,   112,
      -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    49,    -1,    -1,   111,
     112,    -1,   114,    -1,   116,    -1,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     4,    -1,    -1,   111,   112,
      -1,   114,    -1,   116,    -1,    -1,    -1,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,     4,    -1,    -1,   111,   112,
      -1,   114,   115,   116,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    91,     4,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      49,    -1,    -1,   111,   112,    -1,   114,    -1,   116,    -1,
      -1,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    49,
      -1,    -1,   111,   112,    -1,   114,   115,   116,    -1,    -1,
      -1,    90,    91,     4,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    -1,
      -1,    -1,   111,   112,    -1,   114,   115,   116,    -1,    -1,
      90,    91,     4,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    49,    -1,
      -1,   111,   112,    -1,   114,   115,   116,    -1,    -1,    -1,
      -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    49,    -1,    -1,
     111,   112,    -1,   114,   115,   116,    -1,    -1,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    -1,    -1,    -1,   111,
     112,    -1,   114,   115,   116,    -1,    -1,    -1,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    16,    17,    -1,   111,
     112,    -1,   114,    -1,   116,    -1,    -1,    -1,    -1,    -1,
      30,    -1,    32,    33,    -1,    -1,    -1,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    16,    17,    -1,    47,    -1,    -1,
      -1,    51,    52,    -1,    -1,    -1,    56,    -1,    30,    -1,
      32,    33,    62,    63,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,    51,
      52,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    89,
      62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   103,   104,    -1,   106,    -1,   108,   109,
     110,   111,   112,    -1,   114,    -1,    -1,    89,    -1,    -1,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    -1,
      -1,   103,   104,    -1,   106,    -1,   108,   109,   110,   111,
     112,    30,   114,    32,    33,    -1,    -1,   119,    -1,    38,
      -1,    -1,    -1,    -1,    -1,    16,    17,    -1,    47,    -1,
      -1,    -1,    51,    52,    -1,    -1,    -1,    56,    -1,    30,
      -1,    32,    33,    62,    -1,    -1,    -1,    38,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,    -1,
      51,    52,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
      89,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   103,   104,    -1,   106,    -1,   108,
     109,   110,   111,   112,    -1,   114,    -1,    -1,    89,   118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      16,    17,   103,   104,    -1,   106,    -1,   108,   109,   110,
     111,   112,   113,   114,    30,    -1,    32,    33,    -1,    -1,
      -1,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    47,    -1,    -1,    -1,    51,    52,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    -1,    -1,    62,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    -1,    -1,
      -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   103,   104,    -1,
     106,    -1,   108,   109,   110,   111,   112,    -1,   114,     5,
       6,    -1,    -1,    -1,    -1,    -1,    12,    -1,    -1,    -1,
      -1,    -1,    18,    19,    -1,    -1,    22,    -1,    24,    25,
      -1,    -1,    28,    -1,    30,    -1,    32,    33,    -1,    35,
      36,    37,    -1,    -1,    -1,    -1,    42,    43,    -1,    45,
      -1,    47,    -1,    -1,    -1,    -1,    52,    53,    54,    -1,
      56,    57,    -1,    59,    -1,    61,    62
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    86,   122,   124,   123,     0,     7,     8,     9,    10,
      11,    15,    25,    26,    30,    31,    32,    39,    48,    60,
     152,   159,   160,   177,    16,    17,    30,    32,    33,    38,
      47,    51,    52,    56,    62,    89,   103,   104,   106,   108,
     109,   110,   111,   112,   114,   126,   135,   136,   164,   114,
     114,   114,   186,   187,   189,   190,   118,   186,   186,   186,
      33,    24,    25,    47,   184,   185,   184,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,   161,   173,
     174,   175,     3,    13,    15,    21,    25,    27,    29,    34,
      38,    40,    46,    50,    55,    63,    64,   118,   120,   126,
     159,   176,   181,   114,   114,   165,   166,   132,    33,   183,
     114,   126,   114,   114,   114,   126,   126,   126,   137,   126,
     126,   126,    33,   113,   126,   133,   126,     4,    49,    90,
      91,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   111,   112,   114,   116,
      89,   126,    33,    33,    92,   167,   184,   166,    33,   191,
     153,   166,   167,   166,   120,   184,   189,   184,   167,   191,
      92,    90,    90,    90,    90,    90,    90,    90,    90,    90,
      90,    90,    90,   118,   175,   126,   120,   183,   126,    33,
     178,   120,   114,   114,   183,   120,   133,    63,   120,   126,
     126,   114,   114,    87,   194,   120,   176,   126,    33,   149,
     150,   151,   161,   126,    90,   133,   118,   133,   134,   128,
     134,    89,    44,    90,   166,    88,   113,   115,   126,   126,
     126,   126,   126,   126,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   126,   126,   126,    33,   125,   126,
     133,   130,    33,   136,   115,   115,   115,     5,     6,    12,
      18,    19,    22,    24,    25,    28,    30,    32,    33,    35,
      36,    37,    42,    43,    45,    47,    52,    53,    54,    56,
      57,    59,    61,    62,   142,   192,     4,    49,    90,   168,
     188,   124,   168,     4,   166,   155,   168,   158,   126,   126,
     126,   126,   126,   126,   126,   126,   126,   126,   126,   126,
     162,   120,    87,   193,   167,   120,   114,   120,   193,    33,
     112,   126,   167,   193,   120,   114,   193,   120,   118,   126,
     126,   177,   193,   115,    92,   115,    88,   120,   126,   115,
     178,   115,   134,   115,   138,   126,    90,   126,    92,    92,
     113,   134,   118,   114,    41,   166,   114,    41,    41,   118,
     112,   112,   118,    41,   169,   170,   119,   169,   118,     4,
     169,   142,   177,   193,   168,   193,   134,   193,   101,   182,
     183,   115,   168,   193,   126,   193,   179,   115,   115,   119,
     142,    92,   151,   151,   119,   173,   115,   106,   127,   126,
     125,   126,   131,   145,   149,   142,   149,   142,    33,   143,
     142,   146,   146,   146,   142,   173,   118,   126,   172,   173,
     154,   118,   173,   173,   163,   169,   115,   126,    88,   113,
     176,   169,   115,    14,    20,   119,   180,   176,   176,   173,
     142,   129,   161,   113,   115,    33,   139,   140,   141,   115,
     115,   147,    88,   113,   113,   119,   120,   133,   134,   171,
     120,   139,   156,   120,   120,   119,   173,   115,   183,   101,
      23,   173,   176,   133,    92,    58,   173,    85,    90,   195,
     119,    88,    33,   144,   148,   142,    41,    88,   119,   119,
     147,   120,   126,   176,   120,    58,    92,   177,   126,    16,
     104,   141,    92,   119,   142,   119,   120,   157,   193,   115,
     193,   126,   177,   118,   195,    16,   142,   119,   118,   194,
     173,   173,   194,   177,   120,   120,   177,   119,   119
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   121,   122,   123,   122,   124,   124,   125,   125,   126,
     126,   126,   126,   126,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   126,   126,   126,   126,   127,   126,
     126,   126,   126,   126,   126,   128,   129,   126,   126,   126,
     130,   131,   126,   132,   126,   126,   126,   126,   126,   126,
     126,   126,   133,   133,   134,   134,   135,   135,   137,   138,
     136,   139,   139,   140,   140,   141,   141,   141,   142,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   142,   143,   144,   142,   142,   145,   142,
     142,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     146,   146,   147,   147,   148,   149,   149,   149,   150,   150,
     150,   151,   152,   153,   152,   152,   152,   152,   154,   152,
     155,   156,   157,   152,   158,   152,   152,   152,   159,   159,
     159,   159,   159,   160,   160,   160,   160,   162,   163,   161,
     164,   165,   166,   166,   167,   167,   168,   168,   168,   168,
     170,   171,   169,   169,   172,   172,   172,   173,   173,   174,
     174,   175,   175,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   175,   175,   175,   175,   175,   175,   175,
     175,   175,   175,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   177,   177,   178,
     179,   179,   180,   180,   181,   181,   182,   182,   183,   185,
     184,   187,   188,   186,   190,   189,   191,   192,   193,   193,
     194,   194,   195,   195
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     3,     2,     0,     1,     0,     3,
       4,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     5,     3,     4,     4,     6,     3,     4,     0,     6,
       3,     3,     3,     2,     4,     0,     0,     7,     5,     4,
       0,     0,     6,     0,     3,     3,     1,     5,     1,     1,
       1,     3,     3,     1,     1,     0,     3,     1,     0,     0,
       5,     1,     2,     1,     3,     4,     4,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     6,     4,     0,     0,     6,     4,     0,     5,
       1,     3,     3,     2,     4,     4,     3,     1,     3,     1,
       3,     1,     2,     0,     5,     1,     2,     0,     3,     3,
       1,     4,     3,     0,     5,     7,     7,     7,     0,     9,
       0,     0,     0,    12,     0,     7,     2,     1,     4,     4,
       4,     1,     1,     3,     3,     3,     4,     0,     0,     6,
       3,     1,     5,     3,     2,     0,     0,     1,     1,     1,
       0,     0,     3,     0,     3,     4,     1,     1,     0,     2,
       1,     3,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     3,     1,     1,     3,     3,
       1,     1,     1,     4,     4,     4,     5,     7,     5,     2,
       5,     3,     3,     3,     3,     4,     4,     4,     8,     8,
       5,    11,     6,    12,     3,     1,     1,     2,     0,     4,
       2,     0,     4,     3,     6,     8,     3,     1,     1,     0,
       2,     0,     0,     3,     0,     2,     1,     1,     1,     0,
       1,     0,     1,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 274 "parse.y" /* yacc.c:1646  */
    {
			if ( stmts )
				stmts->AsStmtList()->Stmts().append((yyvsp[0].stmt));
			else
				stmts = (yyvsp[0].stmt);

			// Any objects creates from hereon out should not
			// have file positions associated with them.
			set_location(no_location);
			}
#line 2291 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 3:
#line 288 "parse.y" /* yacc.c:1646  */
    { in_debug = true; }
#line 2297 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 4:
#line 289 "parse.y" /* yacc.c:1646  */
    {
			g_curr_debug_expr = (yyvsp[0].expr);
			}
#line 2305 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 301 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2311 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 303 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 2317 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 308 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = (yyvsp[-1].expr); (yyval.expr)->MarkParen();
			}
#line 2326 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 314 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new CloneExpr((yyvsp[-1].expr));
			}
#line 2335 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 320 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_INCR, (yyvsp[0].expr));
			}
#line 2344 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 326 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_DECR, (yyvsp[0].expr));
			}
#line 2353 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 332 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NotExpr((yyvsp[0].expr));
			}
#line 2362 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 338 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NegExpr((yyvsp[0].expr));
			}
#line 2371 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 344 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new PosExpr((yyvsp[0].expr));
			}
#line 2380 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 350 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2389 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 356 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddToExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2398 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 362 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SubExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2407 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 368 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RemoveFromExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2416 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 374 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new TimesExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2425 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 380 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new DivideExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2434 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 386 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new ModExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2443 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 392 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2452 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 398 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2461 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 404 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_EQ, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2470 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 410 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_NE, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2479 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 416 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2488 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 422 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LE, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2497 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 428 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2506 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 434 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GE, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2515 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 440 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new CondExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2524 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 446 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = get_assign_expr((yyvsp[-2].expr), (yyvsp[0].expr), in_init);
			}
#line 2533 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 452 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = add_and_assign_local((yyvsp[-2].id), (yyvsp[0].expr), new Val(1, TYPE_BOOL));
			}
#line 2542 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 458 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].list));
			}
#line 2551 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 464 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));
			Expr* low = (yyvsp[-3].expr) ? (yyvsp[-3].expr) : new ConstExpr(new Val(0, TYPE_COUNT));
			Expr* high = (yyvsp[-1].expr) ? (yyvsp[-1].expr) : new SizeExpr((yyvsp[-5].expr));
			ListExpr* le = new ListExpr(low);
			le->Append(high);
			(yyval.expr) = new IndexExpr((yyvsp[-5].expr), le, true);
			}
#line 2564 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 474 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new FieldExpr((yyvsp[-2].expr), (yyvsp[0].str));
			}
#line 2573 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 480 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new FieldAssignExpr((yyvsp[-2].str), (yyvsp[0].expr));
			}
#line 2582 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 486 "parse.y" /* yacc.c:1646  */
    {
			func_id = current_scope()->GenerateTemporary("anonymous-function");
			func_id->SetInferReturnType(true);
			begin_func(func_id,
				   current_module.c_str(),
				   FUNC_FLAVOR_FUNCTION,
				   0,
				   (yyvsp[-1].func_type));
			}
#line 2596 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 496 "parse.y" /* yacc.c:1646  */
    {
			(yyval.expr) = new FieldAssignExpr((yyvsp[-4].str), new ConstExpr(func_id->ID_Val()));
			}
#line 2604 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 501 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new InExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2613 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 507 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new NotExpr(new InExpr((yyvsp[-2].expr), (yyvsp[0].expr)));
			}
#line 2622 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 513 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));

			bool is_record_ctor = true;

			// If every expression in the list is a field assignment,
			// then treat it as a record constructor, else as a list
			// used for an initializer.

			for ( int i = 0; i < (yyvsp[-1].list)->Exprs().length(); ++i )
				{
				if ( (yyvsp[-1].list)->Exprs()[i]->Tag() != EXPR_FIELD_ASSIGN )
					{
					is_record_ctor = false;
					break;
					}
				}

			if ( is_record_ctor )
				(yyval.expr) = new RecordConstructorExpr((yyvsp[-1].list));
			else
				(yyval.expr) = (yyvsp[-1].list);
			}
#line 2650 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 538 "parse.y" /* yacc.c:1646  */
    {
			// We interpret this as an empty record constructor.
			(yyval.expr) = new RecordConstructorExpr(new ListExpr);
			}
#line 2659 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 545 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new RecordConstructorExpr((yyvsp[-1].list));
			}
#line 2668 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 550 "parse.y" /* yacc.c:1646  */
    { ++in_init; }
#line 2674 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 550 "parse.y" /* yacc.c:1646  */
    { --in_init; }
#line 2680 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 552 "parse.y" /* yacc.c:1646  */
    { // the ++in_init fixes up the parsing of "[x] = y"
			set_location((yylsp[-6]), (yylsp[-2]));
			(yyval.expr) = new TableConstructorExpr((yyvsp[-3].list), (yyvsp[0].attr_l));
			}
#line 2689 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 558 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.expr) = new SetConstructorExpr((yyvsp[-2].list), (yyvsp[0].attr_l));
			}
#line 2698 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 564 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new VectorConstructorExpr((yyvsp[-1].list));
			}
#line 2707 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 570 "parse.y" /* yacc.c:1646  */
    {
			if ( expr_is_table_type_name((yyvsp[-1].expr)) )
				++in_init;
			}
#line 2716 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 576 "parse.y" /* yacc.c:1646  */
    {
			if ( expr_is_table_type_name((yyvsp[-3].expr)) )
				--in_init;
			}
#line 2725 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 582 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			BroType* ctor_type = 0;

			if ( (yyvsp[-5].expr)->Tag() == EXPR_NAME &&
			     (ctor_type = (yyvsp[-5].expr)->AsNameExpr()->Id()->AsType()) )
				{
				switch ( ctor_type->Tag() ) {
				case TYPE_RECORD:
					(yyval.expr) = new RecordCoerceExpr(new RecordConstructorExpr((yyvsp[-2].list)),
					                          ctor_type->AsRecordType());
					break;

				case TYPE_TABLE:
					if ( ctor_type->IsTable() )
						(yyval.expr) = new TableConstructorExpr((yyvsp[-2].list), 0, ctor_type);
					else
						(yyval.expr) = new SetConstructorExpr((yyvsp[-2].list), 0, ctor_type);

					break;

				case TYPE_VECTOR:
					(yyval.expr) = new VectorConstructorExpr((yyvsp[-2].list), ctor_type);
					break;

				default:
					(yyvsp[-5].expr)->Error("constructor type not implemented");
					YYERROR;
				}
				}

			else
				(yyval.expr) = new CallExpr((yyvsp[-5].expr), (yyvsp[-2].list), in_hook > 0);
			}
#line 2765 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 618 "parse.y" /* yacc.c:1646  */
    { ++in_hook; }
#line 2771 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 619 "parse.y" /* yacc.c:1646  */
    {
			--in_hook;
			set_location((yylsp[-2]), (yylsp[0]));
			if ( (yyvsp[0].expr)->Tag() != EXPR_CALL )
				(yyvsp[0].expr)->Error("not a valid hook call expression");
			(yyval.expr) = (yyvsp[0].expr);
			}
#line 2783 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 628 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new HasFieldExpr((yyvsp[-2].expr), (yyvsp[0].str));
			}
#line 2792 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 636 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new ScheduleExpr((yyvsp[-3].expr), (yyvsp[-1].event_expr));
			}
#line 2801 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 642 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));

			ID* id = lookup_ID((yyvsp[0].str), current_module.c_str());
			if ( ! id )
				{
				if ( ! in_debug )
					{
/*	// CHECK THAT THIS IS NOT GLOBAL.
					id = install_ID($1, current_module.c_str(),
							false, is_export);
*/

					yyerror(fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				else
					{
					yyerror(fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				}
			else
				{
				if ( ! id->Type() )
					{
					id->Error("undeclared variable");
					id->SetType(error_type());
					(yyval.expr) = new NameExpr(id);
					}

				else if ( id->IsEnumConst() )
					{
					EnumType* t = id->Type()->AsEnumType();
					int intval = t->Lookup(id->ModuleName(),
							       id->Name());
					if ( intval < 0 )
						reporter->InternalError("enum value not found for %s", id->Name());
					(yyval.expr) = new ConstExpr(new EnumVal(intval, t));
					}
				else
					(yyval.expr) = new NameExpr(id);

				if ( id->IsDeprecated() )
					reporter->Warning("deprecated (%s)", id->Name());
				}
			}
#line 2853 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 691 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.expr) = new ConstExpr((yyvsp[0].val));
			}
#line 2862 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 697 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyvsp[0].re)->Compile();
			(yyval.expr) = new ConstExpr(new PatternVal((yyvsp[0].re)));
			}
#line 2872 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 704 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SizeExpr((yyvsp[-1].expr));
			}
#line 2881 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 712 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyvsp[-2].list)->Append((yyvsp[0].expr));
			}
#line 2890 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 718 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.list) = new ListExpr((yyvsp[0].expr));
			}
#line 2899 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 727 "parse.y" /* yacc.c:1646  */
    { (yyval.list) = new ListExpr(); }
#line 2905 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 732 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-2].re)->AddPat((yyvsp[0].str));
			delete [] (yyvsp[0].str);
			}
#line 2914 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 738 "parse.y" /* yacc.c:1646  */
    {
			(yyval.re) = new RE_Matcher((yyvsp[0].str));
			delete [] (yyvsp[0].str);
			}
#line 2923 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 745 "parse.y" /* yacc.c:1646  */
    { begin_RE(); }
#line 2929 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 745 "parse.y" /* yacc.c:1646  */
    { end_RE(); }
#line 2935 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 746 "parse.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[-2].str); }
#line 2941 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 751 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = NULL;
			}
#line 2950 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 757 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = NULL;
			}
#line 2959 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 776 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			assert(cur_enum_type);

			if ( (yyvsp[-1].val)->Type()->Tag() != TYPE_COUNT )
				reporter->Error("enumerator is not a count constant");
			else
				cur_enum_type->AddName(current_module, (yyvsp[-3].str),
				                       (yyvsp[-1].val)->InternalUnsigned(), is_export, (yyvsp[0].b));
			}
#line 2974 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 788 "parse.y" /* yacc.c:1646  */
    {
			/* We only accept counts as enumerator, but we want to return a nice
			   error message if users triy to use a negative integer (will also
			   catch other cases, but that's fine.)
			*/
			reporter->Error("enumerator is not a count constant");
			}
#line 2986 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 797 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]));
			assert(cur_enum_type);
			cur_enum_type->AddName(current_module, (yyvsp[-1].str), is_export, (yyvsp[0].b));
			}
#line 2996 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 805 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_BOOL);
				}
#line 3005 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 810 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INT);
				}
#line 3014 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 815 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNT);
				}
#line 3023 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 820 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNTER);
				}
#line 3032 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 825 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_DOUBLE);
				}
#line 3041 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 830 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIME);
				}
#line 3050 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 835 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INTERVAL);
				}
#line 3059 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 840 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_STRING);
				}
#line 3068 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 845 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PATTERN);
				}
#line 3077 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 850 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIMER);
				}
#line 3086 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 855 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PORT);
				}
#line 3095 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 89:
#line 860 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ADDR);
				}
#line 3104 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 865 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_SUBNET);
				}
#line 3113 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 870 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ANY);
				}
#line 3122 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 92:
#line 876 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-5]), (yylsp[0]));
				(yyval.type) = new TableType((yyvsp[-3].type_l), (yyvsp[0].type));
				}
#line 3131 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 882 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[0]));
				(yyval.type) = new SetType((yyvsp[-1].type_l), 0);
				}
#line 3140 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 888 "parse.y" /* yacc.c:1646  */
    { ++in_record; }
#line 3146 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 890 "parse.y" /* yacc.c:1646  */
    { --in_record; }
#line 3152 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 892 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-5]), (yylsp[-1]));
				(yyval.type) = new RecordType((yyvsp[-2].type_decl_l));
				}
#line 3161 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 97:
#line 898 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[0]));
				reporter->Error("union type not implemented");
				(yyval.type) = 0;
				}
#line 3171 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 904 "parse.y" /* yacc.c:1646  */
    { set_location((yylsp[-1])); parser_new_enum(); }
#line 3177 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 905 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-4]), (yylsp[0]));
				(yyvsp[-1].type)->UpdateLocationEndInfo((yylsp[0]));
				(yyval.type) = (yyvsp[-1].type);
				}
#line 3187 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 912 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				// $$ = new TypeList();
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3198 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 101:
#line 920 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]));
				// $$ = new TypeList($3);
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3209 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 928 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new VectorType((yyvsp[0].type));
				}
#line 3218 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 934 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-1]), (yylsp[0]));
				(yyval.type) = (yyvsp[0].func_type);
				}
#line 3227 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 104:
#line 940 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType((yyvsp[-1].record), 0, FUNC_FLAVOR_EVENT);
				}
#line 3236 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 946 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType((yyvsp[-1].record), base_type(TYPE_BOOL), FUNC_FLAVOR_HOOK);
				}
#line 3245 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 952 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new FileType((yyvsp[0].type));
				}
#line 3254 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 107:
#line 958 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = new FileType(base_type(TYPE_STRING));
				}
#line 3263 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 964 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new OpaqueType((yyvsp[0].str));
				}
#line 3272 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 970 "parse.y" /* yacc.c:1646  */
    {
			if ( ! (yyvsp[0].id) || ! ((yyval.type) = (yyvsp[0].id)->AsType()) )
				{
				NullStmt here;
				if ( (yyvsp[0].id) )
					(yyvsp[0].id)->Error("not a BRO type", &here);
				(yyval.type) = error_type();
				}
			else
				{
				Ref((yyval.type));

				if ( (yyvsp[0].id)->IsDeprecated() )
					reporter->Warning("deprecated (%s)", (yyvsp[0].id)->Name());
				}
			}
#line 3293 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 990 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_l)->AppendEvenIfNotPure((yyvsp[0].type)); }
#line 3299 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 992 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type_l) = new TypeList((yyvsp[0].type));
			(yyval.type_l)->Append((yyvsp[0].type));
			}
#line 3308 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 1000 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].type_decl_l)->append((yyvsp[0].type_decl));
			}
#line 3316 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 1004 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type_decl_l) = new type_decl_list();
			}
#line 3324 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 1011 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.type_decl) = new TypeDecl((yyvsp[-2].type), (yyvsp[-4].str), (yyvsp[-1].attr_l), (in_record > 0));

			if ( in_record > 0 && cur_decl_type_id )
				broxygen_mgr->RecordField(cur_decl_type_id, (yyval.type_decl), ::filename);
			}
#line 3336 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 1022 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType((yyvsp[0].type_decl_l)); }
#line 3342 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 1024 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType((yyvsp[-1].type_decl_l)); }
#line 3348 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 1026 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType(new type_decl_list()); }
#line 3354 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 1031 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_decl_l)->append((yyvsp[0].type_decl)); }
#line 3360 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 1033 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_decl_l)->append((yyvsp[0].type_decl)); }
#line 3366 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 1035 "parse.y" /* yacc.c:1646  */
    { (yyval.type_decl_l) = new type_decl_list(); (yyval.type_decl_l)->append((yyvsp[0].type_decl)); }
#line 3372 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 1040 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.type_decl) = new TypeDecl((yyvsp[-1].type), (yyvsp[-3].str), (yyvsp[0].attr_l));
			}
#line 3381 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 1048 "parse.y" /* yacc.c:1646  */
    {
			current_module = (yyvsp[-1].str);
			broxygen_mgr->ModuleUsage(::filename, current_module);
			}
#line 3390 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 1053 "parse.y" /* yacc.c:1646  */
    { is_export = true; }
#line 3396 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 1054 "parse.y" /* yacc.c:1646  */
    { is_export = false; }
#line 3402 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 1057 "parse.y" /* yacc.c:1646  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REGULAR);
			broxygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3411 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 1063 "parse.y" /* yacc.c:1646  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_CONST);
			broxygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3420 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 1069 "parse.y" /* yacc.c:1646  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REDEF);
			broxygen_mgr->Redef((yyvsp[-5].id), ::filename);
			}
#line 3429 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 1075 "parse.y" /* yacc.c:1646  */
    { parser_redef_enum((yyvsp[-2].id)); broxygen_mgr->Redef((yyvsp[-2].id), ::filename); }
#line 3435 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 1077 "parse.y" /* yacc.c:1646  */
    {
			// Broxygen already grabbed new enum IDs as the type created them.
			}
#line 3443 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 1082 "parse.y" /* yacc.c:1646  */
    { cur_decl_type_id = (yyvsp[0].id); broxygen_mgr->Redef((yyvsp[0].id), ::filename); }
#line 3449 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 1084 "parse.y" /* yacc.c:1646  */
    { ++in_record; }
#line 3455 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 1086 "parse.y" /* yacc.c:1646  */
    { --in_record; }
#line 3461 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 1088 "parse.y" /* yacc.c:1646  */
    {
			cur_decl_type_id = 0;

			if ( ! (yyvsp[-9].id)->Type() )
				(yyvsp[-9].id)->Error("unknown identifier");
			else
				extend_record((yyvsp[-9].id), (yyvsp[-4].type_decl_l), (yyvsp[-1].attr_l));
			}
#line 3474 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 1098 "parse.y" /* yacc.c:1646  */
    { cur_decl_type_id = (yyvsp[-1].id); broxygen_mgr->StartType((yyvsp[-1].id));  }
#line 3480 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 1100 "parse.y" /* yacc.c:1646  */
    {
			cur_decl_type_id = 0;
			add_type((yyvsp[-5].id), (yyvsp[-2].type), (yyvsp[-1].attr_l));
			broxygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3490 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 1107 "parse.y" /* yacc.c:1646  */
    { }
#line 3496 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 1114 "parse.y" /* yacc.c:1646  */
    { do_atif((yyvsp[-1].expr)); }
#line 3502 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 1116 "parse.y" /* yacc.c:1646  */
    { do_atifdef((yyvsp[-1].str)); }
#line 3508 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 1118 "parse.y" /* yacc.c:1646  */
    { do_atifndef((yyvsp[-1].str)); }
#line 3514 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 141:
#line 1120 "parse.y" /* yacc.c:1646  */
    { do_atendif(); }
#line 3520 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 142:
#line 1122 "parse.y" /* yacc.c:1646  */
    { do_atelse(); }
#line 3526 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 143:
#line 1127 "parse.y" /* yacc.c:1646  */
    {
			begin_func((yyvsp[-1].id), current_module.c_str(),
				FUNC_FLAVOR_FUNCTION, 0, (yyvsp[0].func_type));
			(yyval.func_type) = (yyvsp[0].func_type);
			broxygen_mgr->Identifier((yyvsp[-1].id));
			}
#line 3537 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 1134 "parse.y" /* yacc.c:1646  */
    {
			begin_func((yyvsp[-1].id), current_module.c_str(),
				   FUNC_FLAVOR_EVENT, 0, (yyvsp[0].func_type));
			(yyval.func_type) = (yyvsp[0].func_type);
			}
#line 3547 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 1140 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[0].func_type)->ClearYieldType(FUNC_FLAVOR_HOOK);
			(yyvsp[0].func_type)->SetYieldType(base_type(TYPE_BOOL));
			begin_func((yyvsp[-1].id), current_module.c_str(),
				   FUNC_FLAVOR_HOOK, 0, (yyvsp[0].func_type));
			(yyval.func_type) = (yyvsp[0].func_type);
			}
#line 3559 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1148 "parse.y" /* yacc.c:1646  */
    {
			begin_func((yyvsp[-1].id), current_module.c_str(),
				   FUNC_FLAVOR_EVENT, 1, (yyvsp[0].func_type));
			(yyval.func_type) = (yyvsp[0].func_type);
			}
#line 3569 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1157 "parse.y" /* yacc.c:1646  */
    {
			saved_in_init.push_back(in_init);
			in_init = 0;

			if ( has_attr((yyvsp[-1].attr_l), ATTR_DEPRECATED) )
				current_scope()->ScopeID()->MakeDeprecated();
			}
#line 3581 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1166 "parse.y" /* yacc.c:1646  */
    {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 3590 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1172 "parse.y" /* yacc.c:1646  */
    {
			end_func((yyvsp[-2].stmt), (yyvsp[-5].attr_l));
			}
#line 3598 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1179 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = new ConstExpr((yyvsp[-1].id)->ID_Val()); }
#line 3604 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1184 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id) = current_scope()->GenerateTemporary("anonymous-function");
			begin_func((yyval.id), current_module.c_str(),
				   FUNC_FLAVOR_FUNCTION, 0, (yyvsp[0].func_type));
			}
#line 3614 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1193 "parse.y" /* yacc.c:1646  */
    { (yyval.func_type) = new FuncType((yyvsp[-3].record), (yyvsp[0].type), FUNC_FLAVOR_FUNCTION); }
#line 3620 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1195 "parse.y" /* yacc.c:1646  */
    { (yyval.func_type) = new FuncType((yyvsp[-1].record), base_type(TYPE_VOID), FUNC_FLAVOR_FUNCTION); }
#line 3626 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1200 "parse.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 3632 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 1202 "parse.y" /* yacc.c:1646  */
    { (yyval.type) = 0; }
#line 3638 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 1206 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_NONE; }
#line 3644 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 1207 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_FULL; }
#line 3650 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 1208 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_EXTRA; }
#line 3656 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 1209 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_REMOVE; }
#line 3662 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1213 "parse.y" /* yacc.c:1646  */
    { ++in_init; }
#line 3668 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1213 "parse.y" /* yacc.c:1646  */
    { --in_init; }
#line 3674 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 162:
#line 1214 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 3680 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 1216 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 3686 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 1221 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].list); }
#line 3692 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 1223 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-2].list); }
#line 3698 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1230 "parse.y" /* yacc.c:1646  */
    { (yyval.attr_l) = 0; }
#line 3704 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1235 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-1].attr_l)->append((yyvsp[0].attr)); }
#line 3710 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1237 "parse.y" /* yacc.c:1646  */
    {
			(yyval.attr_l) = new attr_list;
			(yyval.attr_l)->append((yyvsp[0].attr));
			}
#line 3719 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1245 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEFAULT, (yyvsp[0].expr)); }
#line 3725 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1247 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_OPTIONAL); }
#line 3731 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1249 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_REDEF); }
#line 3737 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 174:
#line 1251 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ROTATE_INTERVAL, (yyvsp[0].expr)); }
#line 3743 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1253 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ROTATE_SIZE, (yyvsp[0].expr)); }
#line 3749 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 176:
#line 1255 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ADD_FUNC, (yyvsp[0].expr)); }
#line 3755 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1257 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEL_FUNC, (yyvsp[0].expr)); }
#line 3761 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1259 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_FUNC, (yyvsp[0].expr)); }
#line 3767 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1261 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_CREATE, (yyvsp[0].expr)); }
#line 3773 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1263 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_READ, (yyvsp[0].expr)); }
#line 3779 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1265 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_WRITE, (yyvsp[0].expr)); }
#line 3785 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1267 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_PERSISTENT); }
#line 3791 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1269 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_SYNCHRONIZED); }
#line 3797 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 184:
#line 1271 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ENCRYPT); }
#line 3803 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 185:
#line 1273 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ENCRYPT, (yyvsp[0].expr)); }
#line 3809 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 186:
#line 1275 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_RAW_OUTPUT); }
#line 3815 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 187:
#line 1277 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_MERGEABLE); }
#line 3821 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1279 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_PRIORITY, (yyvsp[0].expr)); }
#line 3827 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1281 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_TYPE_COLUMN, (yyvsp[0].expr)); }
#line 3833 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1283 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_LOG); }
#line 3839 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1285 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ERROR_HANDLER); }
#line 3845 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1287 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEPRECATED); }
#line 3851 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1292 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.stmt) = (yyvsp[-1].stmt);
			if ( (yyvsp[-2].b) )
			    brofiler.DecIgnoreDepth();
			}
#line 3862 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1300 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new PrintStmt((yyvsp[-2].list));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 3873 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1308 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new EventStmt((yyvsp[-2].event_expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 3884 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 196:
#line 1316 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), new NullStmt());
			}
#line 3893 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 197:
#line 1322 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-6]), (yylsp[-3]));
			(yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt));
			}
#line 3902 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1328 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-3]));
			(yyval.stmt) = new SwitchStmt((yyvsp[-3].expr), (yyvsp[-1].case_l));
			}
#line 3911 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1334 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].stmt)->AsForStmt()->AddBody((yyvsp[0].stmt));
			}
#line 3919 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1339 "parse.y" /* yacc.c:1646  */
    {
			(yyval.stmt) = new WhileStmt((yyvsp[-2].expr), (yyvsp[0].stmt));
			}
#line 3927 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 201:
#line 1344 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new NextStmt;
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 3938 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 202:
#line 1352 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new BreakStmt;
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 3949 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 203:
#line 1360 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new FallthroughStmt;
			if ( ! (yyvsp[0].b) )
				brofiler.AddStmt((yyval.stmt));
			}
#line 3960 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 204:
#line 1368 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ReturnStmt(0);
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 3971 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1376 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-2]));
			(yyval.stmt) = new ReturnStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 3982 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1384 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new AddStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 3993 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1392 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new DelStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4004 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 208:
#line 1400 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[-1]));
			(yyval.stmt) = add_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_REGULAR);
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4015 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 209:
#line 1408 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[-2]));
			(yyval.stmt) = add_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_CONST);
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4026 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 210:
#line 1416 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt((yyvsp[-2].expr), (yyvsp[0].stmt), 0, 0, false);
			}
#line 4035 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 211:
#line 1422 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt((yyvsp[-8].expr), (yyvsp[-6].stmt), (yyvsp[-1].stmt), (yyvsp[-4].expr), false);
			if ( (yyvsp[-2].b) )
			    brofiler.DecIgnoreDepth();
			}
#line 4046 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 212:
#line 1431 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt((yyvsp[-2].expr), (yyvsp[0].stmt), 0, 0, true);
			}
#line 4055 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 213:
#line 1437 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt((yyvsp[-8].expr), (yyvsp[-6].stmt), (yyvsp[-1].stmt), (yyvsp[-4].expr), true);
			if ( (yyvsp[-2].b) )
			    brofiler.DecIgnoreDepth();
			}
#line 4066 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 214:
#line 1445 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4077 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 215:
#line 1453 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]), (yylsp[0]));
			(yyval.stmt) = new NullStmt;
			}
#line 4086 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 216:
#line 1459 "parse.y" /* yacc.c:1646  */
    { (yyval.stmt) = new NullStmt; }
#line 4092 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 217:
#line 1464 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].stmt)->AsStmtList()->Stmts().append((yyvsp[0].stmt));
			(yyvsp[-1].stmt)->UpdateLocationEndInfo((yylsp[0]));
			}
#line 4102 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 218:
#line 1470 "parse.y" /* yacc.c:1646  */
    { (yyval.stmt) = new StmtList(); }
#line 4108 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 219:
#line 1475 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.event_expr) = new EventExpr((yyvsp[-3].str), (yyvsp[-1].list));
			ID* id = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( id && id->IsDeprecated() )
				reporter->Warning("deprecated (%s)", id->Name());
			}
#line 4121 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 220:
#line 1487 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-1].case_l)->append((yyvsp[0].c_case)); }
#line 4127 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 221:
#line 1489 "parse.y" /* yacc.c:1646  */
    { (yyval.case_l) = new case_list; }
#line 4133 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1494 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case((yyvsp[-2].list), (yyvsp[0].stmt)); }
#line 4139 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1497 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case(0, (yyvsp[0].stmt)); }
#line 4145 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 224:
#line 1502 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			// This rule needs to be separate from the loop
			// body so that we execute these actions - defining
			// the local variable - prior to parsing the body,
			// which might refer to the variable.
			ID* loop_var = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( loop_var )
				{
				if ( loop_var->IsGlobal() )
					loop_var->Error("global used in for loop");
				}

			else
				loop_var = install_ID((yyvsp[-3].str), current_module.c_str(),
						      false, false);

			id_list* loop_vars = new id_list;
			loop_vars->append(loop_var);

			(yyval.stmt) = new ForStmt(loop_vars, (yyvsp[-1].expr));
			}
#line 4174 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 225:
#line 1528 "parse.y" /* yacc.c:1646  */
    { (yyval.stmt) = new ForStmt((yyvsp[-4].id_l), (yyvsp[-1].expr)); }
#line 4180 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 226:
#line 1533 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].id_l)->append((yyvsp[0].id)); }
#line 4186 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1535 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id_l) = new id_list;
			(yyval.id_l)->append((yyvsp[0].id));
			}
#line 4195 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 228:
#line 1543 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));

			(yyval.id) = lookup_ID((yyvsp[0].str), current_module.c_str());
			if ( (yyval.id) )
				{
				if ( (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a global identifier");
				delete [] (yyvsp[0].str);
				}

			else
				{
				(yyval.id) = install_ID((yyvsp[0].str), current_module.c_str(),
						false, is_export);
				}
			}
#line 4217 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1563 "parse.y" /* yacc.c:1646  */
    { resolving_global_ID = 1; }
#line 4223 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 230:
#line 1564 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 4229 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 231:
#line 1568 "parse.y" /* yacc.c:1646  */
    { defining_global_ID = 1; }
#line 4235 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 232:
#line 1568 "parse.y" /* yacc.c:1646  */
    { defining_global_ID = 0; }
#line 4241 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 233:
#line 1569 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[-1].id); }
#line 4247 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 234:
#line 1573 "parse.y" /* yacc.c:1646  */
    { resolving_global_ID = 0; }
#line 4253 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 235:
#line 1574 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 4259 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1579 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));

			(yyval.id) = lookup_ID((yyvsp[0].str), current_module.c_str(), false, defining_global_ID);
			if ( (yyval.id) )
				{
				if ( ! (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a local identifier");

				if ( (yyval.id)->IsDeprecated() )
					{
					BroType* t = (yyval.id)->Type();

					if ( t->Tag() != TYPE_FUNC ||
					     t->AsFuncType()->Flavor() != FUNC_FLAVOR_FUNCTION )
						reporter->Warning("deprecated (%s)", (yyval.id)->Name());
					}

				delete [] (yyvsp[0].str);
				}

			else
				{
				const char* module_name =
					resolving_global_ID ?
						current_module.c_str() : 0;

				(yyval.id) = install_ID((yyvsp[0].str), module_name,
						true, is_export);
				}
			}
#line 4295 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1615 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.id) = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! (yyval.id) )
				reporter->Error("identifier not defined: %s", (yyvsp[0].str));

			delete [] (yyvsp[0].str);
			}
#line 4309 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 238:
#line 1628 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; }
#line 4315 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 239:
#line 1630 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 4321 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 240:
#line 1634 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; brofiler.IncIgnoreDepth(); }
#line 4327 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1636 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 4333 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1640 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; }
#line 4339 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 243:
#line 1642 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 4345 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
    break;


#line 4349 "/builddir/build/BUILD/bro-2.4.1/build/src/p.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1644 "parse.y" /* yacc.c:1906  */


int yyerror(const char msg[])
	{
	char* msgbuf = new char[strlen(msg) + strlen(last_tok) + 128];

	if ( last_tok[0] == '\n' )
		sprintf(msgbuf, "%s, on previous line", msg);
	else if ( last_tok[0] == '\0' )
		sprintf(msgbuf, "%s, at end of file", msg);
	else
		sprintf(msgbuf, "%s, at or near \"%s\"", msg, last_tok);

	if ( in_debug )
		g_curr_debug_error = copy_string(msg);

	reporter->Error("%s", msgbuf);

	return 0;
	}
